=== modified file 'ChangeLog'
--- ChangeLog	2011-08-07 12:16:39 +0000
+++ ChangeLog	2011-09-11 16:19:40 +0000
@@ -1,6 +1,15 @@
 ChangeLog for forked-daapd
 --------------------------
 
+version 0.19gcd:
+	- no GCD-specific changes.
+
+version 0.19:
+	- more libav 0.7 updates.
+	- database speedups.
+	- fix for iTunes 30-minute timeout.
+	- fixes, big and small.
+
 version 0.18gcd:
 	- build fix for FreeBSD, from Raivo Hool.
 

=== modified file 'aclocal.m4'
--- aclocal.m4	2011-06-20 18:15:23 +0000
+++ aclocal.m4	2011-09-11 16:19:40 +0000
@@ -1428,7 +1428,7 @@
 dnl Test for libgcrypt and define LIBGCRYPT_CFLAGS and LIBGCRYPT_LIBS.
 dnl MINIMUN-VERSION is a string with the version number optionalliy prefixed
 dnl with the API version to also check the API compatibility. Example:
-dnl a MINIMUN-VERSION of 1:1.2.5 won't pass the test unless the installed 
+dnl a MINIMUN-VERSION of 1:1.2.5 won't pass the test unless the installed
 dnl version of libgcrypt is at least 1.2.5 *and* the API number is 1.  Using
 dnl this features allows to prevent build against newer versions of libgcrypt
 dnl with a changed API.
@@ -1444,7 +1444,7 @@
      fi
   fi
 
-  AC_PATH_PROG(LIBGCRYPT_CONFIG, libgcrypt-config, no)
+  AC_PATH_TOOL(LIBGCRYPT_CONFIG, libgcrypt-config, no)
   tmp=ifelse([$1], ,1:1.2.0,$1)
   if echo "$tmp" | grep ':' >/dev/null 2>/dev/null ; then
      req_libgcrypt_api=`echo "$tmp"     | sed 's/\(.*\):\(.*\)/\1/'`
@@ -1472,7 +1472,7 @@
                sed 's/\([[0-9]]*\)\.\([[0-9]]*\)\.\([[0-9]]*\).*/\3/'`
     if test "$major" -gt "$req_major"; then
         ok=yes
-    else 
+    else
         if test "$major" -eq "$req_major"; then
             if test "$minor" -gt "$req_minor"; then
                ok=yes
@@ -1511,6 +1511,21 @@
     LIBGCRYPT_CFLAGS=`$LIBGCRYPT_CONFIG --cflags`
     LIBGCRYPT_LIBS=`$LIBGCRYPT_CONFIG --libs`
     ifelse([$2], , :, [$2])
+    if test x"$host" != x ; then
+      libgcrypt_config_host=`$LIBGCRYPT_CONFIG --host 2>/dev/null || echo none`
+      if test x"$libgcrypt_config_host" != xnone ; then
+        if test x"$libgcrypt_config_host" != x"$host" ; then
+  AC_MSG_WARN([[
+***
+*** The config script $LIBGCRYPT_CONFIG was
+*** built for $libgcrypt_config_host and thus may not match the
+*** used host $host.
+*** You may want to use the configure option --with-libgcrypt-prefix
+*** to specify a matching config script.
+***]])
+        fi
+      fi
+    fi
   else
     LIBGCRYPT_CFLAGS=""
     LIBGCRYPT_LIBS=""

=== modified file 'configure'
--- configure	2011-08-07 12:16:39 +0000
+++ configure	2011-09-11 16:19:40 +0000
@@ -3019,7 +3019,7 @@
 
 # Define the identity of the package.
  PACKAGE=forked-daapd
- VERSION=0.18gcd
+ VERSION=0.19gcd
 
 
 cat >>confdefs.h <<_ACEOF
@@ -15198,8 +15198,9 @@
      fi
   fi
 
-  # Extract the first word of "libgcrypt-config", so it can be a program name with args.
-set dummy libgcrypt-config; ac_word=$2
+  if test -n "$ac_tool_prefix"; then
+  # Extract the first word of "${ac_tool_prefix}libgcrypt-config", so it can be a program name with args.
+set dummy ${ac_tool_prefix}libgcrypt-config; ac_word=$2
 { $as_echo "$as_me:${as_lineno-$LINENO}: checking for $ac_word" >&5
 $as_echo_n "checking for $ac_word... " >&6; }
 if ${ac_cv_path_LIBGCRYPT_CONFIG+:} false; then :
@@ -15225,7 +15226,6 @@
   done
 IFS=$as_save_IFS
 
-  test -z "$ac_cv_path_LIBGCRYPT_CONFIG" && ac_cv_path_LIBGCRYPT_CONFIG="no"
   ;;
 esac
 fi
@@ -15239,6 +15239,63 @@
 fi
 
 
+fi
+if test -z "$ac_cv_path_LIBGCRYPT_CONFIG"; then
+  ac_pt_LIBGCRYPT_CONFIG=$LIBGCRYPT_CONFIG
+  # Extract the first word of "libgcrypt-config", so it can be a program name with args.
+set dummy libgcrypt-config; ac_word=$2
+{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for $ac_word" >&5
+$as_echo_n "checking for $ac_word... " >&6; }
+if ${ac_cv_path_ac_pt_LIBGCRYPT_CONFIG+:} false; then :
+  $as_echo_n "(cached) " >&6
+else
+  case $ac_pt_LIBGCRYPT_CONFIG in
+  [\\/]* | ?:[\\/]*)
+  ac_cv_path_ac_pt_LIBGCRYPT_CONFIG="$ac_pt_LIBGCRYPT_CONFIG" # Let the user override the test with a path.
+  ;;
+  *)
+  as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
+for as_dir in $PATH
+do
+  IFS=$as_save_IFS
+  test -z "$as_dir" && as_dir=.
+    for ac_exec_ext in '' $ac_executable_extensions; do
+  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+    ac_cv_path_ac_pt_LIBGCRYPT_CONFIG="$as_dir/$ac_word$ac_exec_ext"
+    $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
+    break 2
+  fi
+done
+  done
+IFS=$as_save_IFS
+
+  ;;
+esac
+fi
+ac_pt_LIBGCRYPT_CONFIG=$ac_cv_path_ac_pt_LIBGCRYPT_CONFIG
+if test -n "$ac_pt_LIBGCRYPT_CONFIG"; then
+  { $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_pt_LIBGCRYPT_CONFIG" >&5
+$as_echo "$ac_pt_LIBGCRYPT_CONFIG" >&6; }
+else
+  { $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
+$as_echo "no" >&6; }
+fi
+
+  if test "x$ac_pt_LIBGCRYPT_CONFIG" = x; then
+    LIBGCRYPT_CONFIG="no"
+  else
+    case $cross_compiling:$ac_tool_warned in
+yes:)
+{ $as_echo "$as_me:${as_lineno-$LINENO}: WARNING: using cross tools not prefixed with host triplet" >&5
+$as_echo "$as_me: WARNING: using cross tools not prefixed with host triplet" >&2;}
+ac_tool_warned=yes ;;
+esac
+    LIBGCRYPT_CONFIG=$ac_pt_LIBGCRYPT_CONFIG
+  fi
+else
+  LIBGCRYPT_CONFIG="$ac_cv_path_LIBGCRYPT_CONFIG"
+fi
+
   tmp=1:1.2.0
   if echo "$tmp" | grep ':' >/dev/null 2>/dev/null ; then
      req_libgcrypt_api=`echo "$tmp"     | sed 's/\(.*\):\(.*\)/\1/'`
@@ -15311,6 +15368,29 @@
     LIBGCRYPT_CFLAGS=`$LIBGCRYPT_CONFIG --cflags`
     LIBGCRYPT_LIBS=`$LIBGCRYPT_CONFIG --libs`
     :
+    if test x"$host" != x ; then
+      libgcrypt_config_host=`$LIBGCRYPT_CONFIG --host 2>/dev/null || echo none`
+      if test x"$libgcrypt_config_host" != xnone ; then
+        if test x"$libgcrypt_config_host" != x"$host" ; then
+  { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING:
+***
+*** The config script $LIBGCRYPT_CONFIG was
+*** built for $libgcrypt_config_host and thus may not match the
+*** used host $host.
+*** You may want to use the configure option --with-libgcrypt-prefix
+*** to specify a matching config script.
+***" >&5
+$as_echo "$as_me: WARNING:
+***
+*** The config script $LIBGCRYPT_CONFIG was
+*** built for $libgcrypt_config_host and thus may not match the
+*** used host $host.
+*** You may want to use the configure option --with-libgcrypt-prefix
+*** to specify a matching config script.
+***" >&2;}
+        fi
+      fi
+    fi
   else
     LIBGCRYPT_CFLAGS=""
     LIBGCRYPT_LIBS=""

=== modified file 'configure.in'
--- configure.in	2011-08-07 12:16:39 +0000
+++ configure.in	2011-09-11 16:19:40 +0000
@@ -3,7 +3,7 @@
 AC_INIT(config.h.in)
 AC_CONFIG_MACRO_DIR([m4])
 AC_CONFIG_HEADER(config.h)
-AM_INIT_AUTOMAKE(forked-daapd, 0.18gcd)
+AM_INIT_AUTOMAKE(forked-daapd, 0.19gcd)
 
 dnl Checks for programs.
 AC_PROG_CC([clang llvm-gcc])

=== added file 'ffmpeg/libav-0.7.patch'
--- ffmpeg/libav-0.7.patch	1970-01-01 00:00:00 +0000
+++ ffmpeg/libav-0.7.patch	2011-09-11 15:51:59 +0000
@@ -0,0 +1,81 @@
+--- libav/libavformat/mov.c	2011-08-09 14:03:47.622688230 -0700
++++ libav/libavformat/mov.c	2011-08-09 14:09:33.181475099 -0700
+@@ -81,19 +81,46 @@
+ 
+ static const MOVParseTableEntry mov_default_parse_table[];
+ 
+-static int mov_metadata_trkn(MOVContext *c, AVIOContext *pb, unsigned len)
++static int mov_metadata_trkn(MOVContext *c, AVIOContext *pb, unsigned len, const char *key)
+ {
+     char buf[16];
+ 
+     avio_rb16(pb); // unknown
+     snprintf(buf, sizeof(buf), "%d", avio_rb16(pb));
+-    av_dict_set(&c->fc->metadata, "track", buf, 0);
++    av_dict_set(&c->fc->metadata, key, buf, 0);
+ 
+     avio_rb16(pb); // total tracks
+ 
+     return 0;
+ }
+ 
++static int mov_metadata_int8(MOVContext *c, AVIOContext *pb, unsigned len, const char *key)
++{
++    char buf[16];
++
++    /* bypass padding bytes */
++    get_byte(pb);
++    get_byte(pb);
++    get_byte(pb);
++
++    snprintf(buf, sizeof(buf-1), "%hu", get_byte(pb));
++    buf[sizeof(buf)-1] = 0;
++    av_metadata_set2(&c->fc->metadata, key, buf, 0);
++
++    return 0;
++}
++
++static int mov_metadata_stik(MOVContext *c, AVIOContext *pb, unsigned len, const char *key)
++{
++    char buf[16];
++
++    snprintf(buf, sizeof(buf-1), "%hu", get_byte(pb));
++    buf[sizeof(buf)-1] = 0;
++    av_metadata_set2(&c->fc->metadata, key, buf, 0);
++
++    return 0;
++}
++
+ static const uint32_t mac_to_unicode[128] = {
+     0x00C4,0x00C5,0x00C7,0x00C9,0x00D1,0x00D6,0x00DC,0x00E1,
+     0x00E0,0x00E2,0x00E4,0x00E3,0x00E5,0x00E7,0x00E9,0x00E8,
+@@ -140,7 +167,7 @@
+     const char *key = NULL;
+     uint16_t str_size, langcode = 0;
+     uint32_t data_type = 0;
+-    int (*parse)(MOVContext*, AVIOContext*, unsigned) = NULL;
++    int (*parse)(MOVContext*, AVIOContext*, unsigned, const char *) = NULL;
+ 
+     switch (atom.type) {
+     case MKTAG(0xa9,'n','a','m'): key = "title";     break;
+@@ -162,6 +189,11 @@
+     case MKTAG( 't','v','s','h'): key = "show";      break;
+     case MKTAG( 't','v','e','n'): key = "episode_id";break;
+     case MKTAG( 't','v','n','n'): key = "network";   break;
++    case MKTAG( 't','v','e','s'): key = "episode_sort";
++    case MKTAG( 't','v','s','n'): key = "season_number";
++        parse = mov_metadata_int8; break;
++    case MKTAG( 's','t','i','k'): key = "stik";
++        parse = mov_metadata_stik; break;    
+     case MKTAG( 't','r','k','n'): key = "track";
+         parse = mov_metadata_trkn; break;
+     }
+@@ -198,7 +230,7 @@
+     str_size = FFMIN3(sizeof(str)-1, str_size, atom.size);
+ 
+     if (parse)
+-        parse(c, pb, str_size);
++        parse(c, pb, str_size, key);
+     else {
+         if (data_type == 3 || (data_type == 0 && langcode < 0x800)) { // MAC Encoded
+             mov_read_mac_string(c, pb, str_size, str, sizeof(str));

=== modified file 'ltmain.sh'
--- ltmain.sh	2011-08-07 11:40:27 +0000
+++ ltmain.sh	2011-09-11 15:51:59 +0000
@@ -69,7 +69,7 @@
 #         compiler:		$LTCC
 #         compiler flags:		$LTCFLAGS
 #         linker:		$LD (gnu? $with_gnu_ld)
-#         $progname:	(GNU libtool) 2.4 Debian-2.4-3
+#         $progname:	(GNU libtool) 2.4 Debian-2.4-4
 #         automake:	$automake_version
 #         autoconf:	$autoconf_version
 #
@@ -79,7 +79,7 @@
 
 PROGRAM=libtool
 PACKAGE=libtool
-VERSION="2.4 Debian-2.4-3"
+VERSION="2.4 Debian-2.4-4"
 TIMESTAMP=""
 package_revision=1.3293
 

=== modified file 'src/RSP2SQL.g'
--- src/RSP2SQL.g	2011-08-07 11:40:27 +0000
+++ src/RSP2SQL.g	2011-09-11 15:51:59 +0000
@@ -205,6 +205,7 @@
 			}
 
 			$result = field->factory->newRaw(field->factory);
+			$result->append8($result, "f.");
 			$result->appendS($result, field);
 			$result->append8($result, op);
 			$result->append8($result, "'");
@@ -289,6 +290,7 @@
 			}
 
 			$result = field->factory->newRaw(field->factory);
+			$result->append8($result, "f.");
 			$result->appendS($result, field);
 			$result->append8($result, op);
 			$result->appendS($result, $i->getText($i));
@@ -362,6 +364,7 @@
 			}
 
 			$result = field->factory->newRaw(field->factory);
+			$result->append8($result, "f.");
 			$result->appendS($result, field);
 			$result->append8($result, op);
 			$result->append8($result, buf);

=== modified file 'src/artwork.c'
--- src/artwork.c	2011-06-20 18:15:23 +0000
+++ src/artwork.c	2011-09-11 16:19:40 +0000
@@ -264,6 +264,7 @@
   dst->width = out_w;
   dst->height = out_h;
 
+#if LIBAVFORMAT_VERSION_MAJOR <= 52 || (LIBAVFORMAT_VERSION_MAJOR == 53 && LIBAVCODEC_VERSION_MINOR <= 1)
   ret = av_set_parameters(dst_ctx, NULL);
   if (ret < 0)
     {
@@ -272,6 +273,7 @@
       ret = -1;
       goto out_free_dst;
     }
+#endif
 
   /* Open encoder */
   ret = avcodec_open(dst, img_encoder);
@@ -410,7 +412,11 @@
   pkt.data = outbuf;
   pkt.size = ret;
 
+#if LIBAVFORMAT_VERSION_MAJOR >= 53 || (LIBAVFORMAT_VERSION_MAJOR == 53 && LIBAVCODEC_VERSION_MINOR >= 3)
+  ret = avformat_write_header(dst_ctx, NULL);
+#else
   ret = av_write_header(dst_ctx);
+#endif
   if (ret != 0)
     {
       DPRINTF(E_LOG, L_ART, "Could not write artwork header: %s\n", strerror(AVUNERROR(ret)));
@@ -499,7 +505,13 @@
 
   DPRINTF(E_DBG, L_ART, "Artwork request parameters: max w = %d, max h = %d\n", max_w, max_h);
 
+  src_ctx = NULL;
+
+#if LIBAVFORMAT_VERSION_MAJOR >= 53 || (LIBAVFORMAT_VERSION_MAJOR == 53 && LIBAVCODEC_VERSION_MINOR >= 3)
+  ret = avformat_open_input(&src_ctx, filename, NULL, NULL);
+#else
   ret = av_open_input_file(&src_ctx, filename, NULL, 0, NULL);
+#endif
   if (ret < 0)
     {
       DPRINTF(E_WARN, L_ART, "Cannot open artwork file '%s': %s\n", filename, strerror(AVUNERROR(ret)));

=== modified file 'src/daap_query.gperf'
--- src/daap_query.gperf	2011-04-09 11:41:55 +0000
+++ src/daap_query.gperf	2011-09-11 15:51:59 +0000
@@ -10,30 +10,30 @@
 %omit-struct-type
 struct dmap_query_field_map;
 %%
-"dmap.itemname",              "title",            0
-"dmap.itemid",                "id",               1
-"daap.songalbum",             "album",            0
-"daap.songalbumid",           "songalbumid",      1
-"daap.songartist",            "artist",           0
-"daap.songalbumartist",       "album_artist",     0
-"daap.songbitrate",           "bitrate",          1
-"daap.songcomment",           "comment",          0
-"daap.songcompilation",       "compilation",      1
-"daap.songcomposer",          "composer",         0
-"daap.songdatakind",          "data_kind",        1
-"daap.songdataurl",           "url",              0
-"daap.songdateadded",         "time_added",       1
-"daap.songdatemodified",      "time_modified",    1
-"daap.songdescription",       "description",      0
-"daap.songdisccount",         "total_discs",      1
-"daap.songdiscnumber",        "disc",             1
-"daap.songformat",            "type",             0
-"daap.songgenre",             "genre",            0
-"daap.songsamplerate",        "samplerate",       1
-"daap.songsize",              "file_size",        1
-"daap.songstoptime",          "song_length",      1
-"daap.songtime",              "song_length",      1
-"daap.songtrackcount",        "total_tracks",     1
-"daap.songtracknumber",       "track",            1
-"daap.songyear",              "year",             1
-"com.apple.itunes.mediakind", "media_kind",       1
+"dmap.itemname",              "f.title",            0
+"dmap.itemid",                "f.id",               1
+"daap.songalbum",             "f.album",            0
+"daap.songalbumid",           "f.songalbumid",      1
+"daap.songartist",            "f.artist",           0
+"daap.songalbumartist",       "f.album_artist",     0
+"daap.songbitrate",           "f.bitrate",          1
+"daap.songcomment",           "f.comment",          0
+"daap.songcompilation",       "f.compilation",      1
+"daap.songcomposer",          "f.composer",         0
+"daap.songdatakind",          "f.data_kind",        1
+"daap.songdataurl",           "f.url",              0
+"daap.songdateadded",         "f.time_added",       1
+"daap.songdatemodified",      "f.time_modified",    1
+"daap.songdescription",       "f.description",      0
+"daap.songdisccount",         "f.total_discs",      1
+"daap.songdiscnumber",        "f.disc",             1
+"daap.songformat",            "f.type",             0
+"daap.songgenre",             "f.genre",            0
+"daap.songsamplerate",        "f.samplerate",       1
+"daap.songsize",              "f.file_size",        1
+"daap.songstoptime",          "f.song_length",      1
+"daap.songtime",              "f.song_length",      1
+"daap.songtrackcount",        "f.total_tracks",     1
+"daap.songtracknumber",       "f.track",            1
+"daap.songyear",              "f.year",             1
+"com.apple.itunes.mediakind", "f.media_kind",       1

=== modified file 'src/db.c'
--- src/db.c	2011-06-20 18:15:23 +0000
+++ src/db.c	2011-09-11 16:19:40 +0000
@@ -276,9 +276,9 @@
 static const char *sort_clause[] =
   {
     "",
-    "ORDER BY title_sort ASC",
-    "ORDER BY album_sort ASC, disc ASC, track ASC",
-    "ORDER BY artist_sort ASC",
+    "ORDER BY f.title_sort ASC",
+    "ORDER BY f.album_sort ASC, f.disc ASC, f.track ASC",
+    "ORDER BY f.artist_sort ASC",
   };
 
 static char *db_path;
@@ -591,6 +591,35 @@
 }
 
 
+/* Maintenance and DB hygiene */
+static void
+db_analyze(void)
+{
+  char *query = "ANALYZE;";
+  char *errmsg;
+  int ret;
+
+  DPRINTF(E_DBG, L_DB, "Running query '%s'\n", query);
+
+  ret = db_exec(query, &errmsg);
+  if (ret != SQLITE_OK)
+    {
+      DPRINTF(E_LOG, L_DB, "ANALYZE failed: %s\n", errmsg);
+
+      sqlite3_free(errmsg);
+    }
+}
+
+void
+db_hook_post_scan(void)
+{
+  DPRINTF(E_DBG, L_DB, "Running post-scan DB maintenance tasks...\n");
+
+  db_analyze();
+
+  DPRINTF(E_DBG, L_DB, "Done with post-scan DB maintenance\n");
+}
+
 void
 db_purge_cruft(time_t ref)
 {
@@ -600,7 +629,7 @@
   char *queries[3] = { NULL, NULL, NULL };
   char *queries_tmpl[3] =
     {
-      "DELETE FROM playlistitems WHERE playlistid IN (SELECT id FROM playlists WHERE type <> 1 AND db_timestamp < %" PRIi64 ");",
+      "DELETE FROM playlistitems WHERE playlistid IN (SELECT id FROM playlists p WHERE p.type <> 1 AND p.db_timestamp < %" PRIi64 ");",
       "DELETE FROM playlists WHERE type <> 1 AND db_timestamp < %" PRIi64 ";",
       "DELETE FROM files WHERE db_timestamp < %" PRIi64 ";"
     };
@@ -670,6 +699,11 @@
 
   ret = sqlite3_column_int(stmt, 0);
 
+#ifdef DB_PROFILE
+  while (db_blocking_step(stmt) == SQLITE_ROW)
+    ; /* EMPTY */
+#endif
+
   sqlite3_finalize(stmt);
 
   return ret;
@@ -726,9 +760,9 @@
   int ret;
 
   if (qp->filter)
-    count = sqlite3_mprintf("SELECT COUNT(*) FROM files WHERE disabled = 0 AND %s;", qp->filter);
+    count = sqlite3_mprintf("SELECT COUNT(*) FROM files f WHERE f.disabled = 0 AND %s;", qp->filter);
   else
-    count = sqlite3_mprintf("SELECT COUNT(*) FROM files WHERE disabled = 0;");
+    count = sqlite3_mprintf("SELECT COUNT(*) FROM files f WHERE f.disabled = 0;");
 
   if (!count)
     {
@@ -751,13 +785,13 @@
   sort = sort_clause[qp->sort];
 
   if (idx && qp->filter)
-    query = sqlite3_mprintf("SELECT * FROM files WHERE disabled = 0 AND %s %s %s;", qp->filter, sort, idx);
+    query = sqlite3_mprintf("SELECT f.* FROM files f WHERE f.disabled = 0 AND %s %s %s;", qp->filter, sort, idx);
   else if (idx)
-    query = sqlite3_mprintf("SELECT * FROM files WHERE disabled = 0 %s %s;", sort, idx);
+    query = sqlite3_mprintf("SELECT f.* FROM files f WHERE f.disabled = 0 %s %s;", sort, idx);
   else if (qp->filter)
-    query = sqlite3_mprintf("SELECT * FROM files WHERE disabled = 0 AND %s %s;", qp->filter, sort);
+    query = sqlite3_mprintf("SELECT f.* FROM files f WHERE f.disabled = 0 AND %s %s;", qp->filter, sort);
   else
-    query = sqlite3_mprintf("SELECT * FROM files WHERE disabled = 0 %s;", sort);
+    query = sqlite3_mprintf("SELECT f.* FROM files f WHERE f.disabled = 0 %s;", sort);
 
   if (!query)
     {
@@ -777,7 +811,7 @@
   char *idx;
   int ret;
 
-  qp->results = db_get_count("SELECT COUNT(*) FROM playlists WHERE disabled = 0;");
+  qp->results = db_get_count("SELECT COUNT(*) FROM playlists p WHERE p.disabled = 0;");
   if (qp->results < 0)
     return -1;
 
@@ -787,13 +821,13 @@
     return -1;
 
   if (idx && qp->filter)
-    query = sqlite3_mprintf("SELECT * FROM playlists WHERE disabled = 0 AND %s %s;", qp->filter, idx);
+    query = sqlite3_mprintf("SELECT f.* FROM playlists f WHERE f.disabled = 0 AND %s %s;", qp->filter, idx);
   else if (idx)
-    query = sqlite3_mprintf("SELECT * FROM playlists WHERE disabled = 0 %s;", idx);
+    query = sqlite3_mprintf("SELECT f.* FROM playlists f WHERE f.disabled = 0 %s;", idx);
   else if (qp->filter)
-    query = sqlite3_mprintf("SELECT * FROM playlists WHERE disabled = 0 AND %s;", qp->filter);
+    query = sqlite3_mprintf("SELECT f.* FROM playlists f WHERE f.disabled = 0 AND %s;", qp->filter);
   else
-    query = sqlite3_mprintf("SELECT * FROM playlists WHERE disabled = 0;");
+    query = sqlite3_mprintf("SELECT f.* FROM playlists f WHERE f.disabled = 0;");
 
   if (!query)
     {
@@ -815,11 +849,11 @@
   int ret;
 
   if (qp->filter)
-    count = sqlite3_mprintf("SELECT COUNT(*) FROM files JOIN playlistitems ON files.path = playlistitems.filepath"
-			    " WHERE playlistitems.playlistid = %d AND files.disabled = 0 AND %s;", qp->id, qp->filter);
+    count = sqlite3_mprintf("SELECT COUNT(*) FROM files f JOIN playlistitems pi ON f.path = pi.filepath"
+			    " WHERE pi.playlistid = %d AND f.disabled = 0 AND %s;", qp->id, qp->filter);
   else
-    count = sqlite3_mprintf("SELECT COUNT(*) FROM files JOIN playlistitems ON files.path = playlistitems.filepath"
-			    " WHERE playlistitems.playlistid = %d AND files.disabled = 0;", qp->id);
+    count = sqlite3_mprintf("SELECT COUNT(*) FROM files f JOIN playlistitems pi ON f.path = pi.filepath"
+			    " WHERE pi.playlistid = %d AND f.disabled = 0;", qp->id);
 
   if (!count)
     {
@@ -840,20 +874,20 @@
     return -1;
 
   if (idx && qp->filter)
-    query = sqlite3_mprintf("SELECT files.* FROM files JOIN playlistitems ON files.path = playlistitems.filepath"
-			    " WHERE playlistitems.playlistid = %d AND files.disabled = 0 AND %s ORDER BY playlistitems.id ASC %s;",
+    query = sqlite3_mprintf("SELECT f.* FROM files f JOIN playlistitems pi ON f.path = pi.filepath"
+			    " WHERE pi.playlistid = %d AND f.disabled = 0 AND %s ORDER BY pi.id ASC %s;",
 			    qp->id, qp->filter, idx);
   else if (idx)
-    query = sqlite3_mprintf("SELECT files.* FROM files JOIN playlistitems ON files.path = playlistitems.filepath"
-			    " WHERE playlistitems.playlistid = %d AND files.disabled = 0 ORDER BY playlistitems.id ASC %s;",
+    query = sqlite3_mprintf("SELECT f.* FROM files f JOIN playlistitems pi ON f.path = pi.filepath"
+			    " WHERE pi.playlistid = %d AND f.disabled = 0 ORDER BY pi.id ASC %s;",
 			    qp->id, idx);
   else if (qp->filter)
-    query = sqlite3_mprintf("SELECT files.* FROM files JOIN playlistitems ON files.path = playlistitems.filepath"
-			    " WHERE playlistitems.playlistid = %d AND files.disabled = 0 AND %s ORDER BY playlistitems.id ASC;",
+    query = sqlite3_mprintf("SELECT f.* FROM files f JOIN playlistitems pi ON f.path = pi.filepath"
+			    " WHERE pi.playlistid = %d AND f.disabled = 0 AND %s ORDER BY pi.id ASC;",
 			    qp->id, qp->filter);
   else
-    query = sqlite3_mprintf("SELECT files.* FROM files JOIN playlistitems ON files.path = playlistitems.filepath"
-			    " WHERE playlistitems.playlistid = %d AND files.disabled = 0 ORDER BY playlistitems.id ASC;",
+    query = sqlite3_mprintf("SELECT f.* FROM files f JOIN playlistitems pi ON f.path = pi.filepath"
+			    " WHERE pi.playlistid = %d AND f.disabled = 0 ORDER BY pi.id ASC;",
 			    qp->id);
 
   if (!query)
@@ -882,7 +916,7 @@
   else
     filter = "1 = 1";
 
-  count = sqlite3_mprintf("SELECT COUNT(*) FROM files WHERE disabled = 0 AND %s AND %s;", filter, smartpl_query);
+  count = sqlite3_mprintf("SELECT COUNT(*) FROM files f WHERE f.disabled = 0 AND %s AND %s;", filter, smartpl_query);
   if (!count)
     {
       DPRINTF(E_LOG, L_DB, "Out of memory for count query string\n");
@@ -906,7 +940,7 @@
 
   sort = sort_clause[qp->sort];
 
-  query = sqlite3_mprintf("SELECT * FROM files WHERE disabled = 0 AND %s AND %s %s %s;", smartpl_query, filter, sort, idx);
+  query = sqlite3_mprintf("SELECT f.* FROM files f WHERE f.disabled = 0 AND %s AND %s %s %s;", smartpl_query, filter, sort, idx);
   if (!query)
     {
       DPRINTF(E_LOG, L_DB, "Out of memory for query string\n");
@@ -962,7 +996,7 @@
   char *idx;
   int ret;
 
-  qp->results = db_get_count("SELECT COUNT(DISTINCT songalbumid) FROM files WHERE disabled = 0;");
+  qp->results = db_get_count("SELECT COUNT(DISTINCT f.songalbumid) FROM files f WHERE f.disabled = 0;");
   if (qp->results < 0)
     return -1;
 
@@ -972,13 +1006,13 @@
     return -1;
 
   if (idx && qp->filter)
-    query = sqlite3_mprintf("SELECT COUNT(*), g.id, g.persistentid, f.album_artist, g.name FROM files f JOIN groups g ON f.songalbumid = g.persistentid GROUP BY f.album, g.name HAVING g.type = %d AND disabled = 0 AND %s %s;", G_ALBUMS, qp->filter, idx);
+    query = sqlite3_mprintf("SELECT COUNT(*), g.id, g.persistentid, f.album_artist, g.name FROM files f, groups g WHERE f.songalbumid = g.persistentid AND g.type = %d AND f.disabled = 0 AND %s GROUP BY f.album, g.name %s;", G_ALBUMS, qp->filter, idx);
   else if (idx)
-    query = sqlite3_mprintf("SELECT COUNT(*), g.id, g.persistentid, f.album_artist, g.name FROM files f JOIN groups g ON f.songalbumid = g.persistentid GROUP BY f.album, g.name HAVING g.type = %d AND disabled = 0 %s;", G_ALBUMS, idx);
+    query = sqlite3_mprintf("SELECT COUNT(*), g.id, g.persistentid, f.album_artist, g.name FROM files f, groups g WHERE f.songalbumid = g.persistentid AND g.type = %d AND f.disabled = 0 GROUP BY f.album, g.name %s;", G_ALBUMS, idx);
   else if (qp->filter)
-    query = sqlite3_mprintf("SELECT COUNT(*), g.id, g.persistentid, f.album_artist, g.name FROM files f JOIN groups g ON f.songalbumid = g.persistentid GROUP BY f.album, g.name HAVING g.type = %d AND disabled = 0 AND %s;", G_ALBUMS, qp->filter);
+    query = sqlite3_mprintf("SELECT COUNT(*), g.id, g.persistentid, f.album_artist, g.name FROM files f, groups g WHERE f.songalbumid = g.persistentid AND g.type = %d AND f.disabled = 0 AND %s GROUP BY f.album, g.name;", G_ALBUMS, qp->filter);
   else
-    query = sqlite3_mprintf("SELECT COUNT(*), g.id, g.persistentid, f.album_artist, g.name FROM files f JOIN groups g ON f.songalbumid = g.persistentid GROUP BY f.album, g.name HAVING g.type = %d AND disabled = 0;", G_ALBUMS);
+    query = sqlite3_mprintf("SELECT COUNT(*), g.id, g.persistentid, f.album_artist, g.name FROM files f, groups g WHERE f.songalbumid = g.persistentid AND g.type = %d AND f.disabled = 0 GROUP BY f.album, g.name;", G_ALBUMS);
 
   if (!query)
     {
@@ -1003,8 +1037,8 @@
   switch (gt)
     {
       case G_ALBUMS:
-	count = sqlite3_mprintf("SELECT COUNT(*) FROM files JOIN groups ON files.songalbumid = groups.persistentid"
-				" WHERE groups.id = %d AND files.disabled = 0;", qp->id);
+	count = sqlite3_mprintf("SELECT COUNT(*) FROM files f JOIN groups g ON f.songalbumid = g.persistentid"
+				" WHERE g.id = %d AND f.disabled = 0;", qp->id);
 	break;
 
       default:
@@ -1028,8 +1062,8 @@
   switch (gt)
     {
       case G_ALBUMS:
-	query = sqlite3_mprintf("SELECT files.* FROM files JOIN groups ON files.songalbumid = groups.persistentid"
-				" WHERE groups.id = %d AND files.disabled = 0;", qp->id);
+	query = sqlite3_mprintf("SELECT f.* FROM files f JOIN groups g ON f.songalbumid = g.persistentid"
+				" WHERE g.id = %d AND f.disabled = 0;", qp->id);
 	break;
     }
 
@@ -1056,9 +1090,9 @@
   switch (gt)
     {
       case G_ALBUMS:
-	count = sqlite3_mprintf("SELECT COUNT(DISTINCT(SUBSTR(files.path, 1, LENGTH(files.path) - LENGTH(files.fname) - 1)))"
-				" FROM files JOIN groups ON files.songalbumid = groups.persistentid"
-				" WHERE groups.id = %d AND files.disabled = 0;", qp->id);
+	count = sqlite3_mprintf("SELECT COUNT(DISTINCT(SUBSTR(f.path, 1, LENGTH(f.path) - LENGTH(f.fname) - 1)))"
+				" FROM files f JOIN groups g ON f.songalbumid = g.persistentid"
+				" WHERE g.id = %d AND f.disabled = 0;", qp->id);
 	break;
 
       default:
@@ -1082,9 +1116,9 @@
   switch (gt)
     {
       case G_ALBUMS:
-	query = sqlite3_mprintf("SELECT DISTINCT(SUBSTR(files.path, 1, LENGTH(files.path) - LENGTH(files.fname) - 1))"
-				" FROM files JOIN groups ON files.songalbumid = groups.persistentid"
-				" WHERE groups.id = %d AND files.disabled = 0;", qp->id);
+	query = sqlite3_mprintf("SELECT DISTINCT(SUBSTR(f.path, 1, LENGTH(f.path) - LENGTH(f.fname) - 1))"
+				" FROM files f JOIN groups g ON f.songalbumid = g.persistentid"
+				" WHERE g.id = %d AND f.disabled = 0;", qp->id);
 	break;
     }
 
@@ -1108,10 +1142,10 @@
   int ret;
 
   if (qp->filter)
-    count = sqlite3_mprintf("SELECT COUNT(DISTINCT %s) FROM files WHERE data_kind = 0 AND disabled = 0 AND %s != '' AND %s;",
+    count = sqlite3_mprintf("SELECT COUNT(DISTINCT f.%s) FROM files f WHERE f.data_kind = 0 AND f.disabled = 0 AND f.%s != '' AND %s;",
 			    field, field, qp->filter);
   else
-    count = sqlite3_mprintf("SELECT COUNT(DISTINCT %s) FROM files WHERE data_kind = 0 AND disabled = 0 AND %s != '';",
+    count = sqlite3_mprintf("SELECT COUNT(DISTINCT f.%s) FROM files f WHERE f.data_kind = 0 AND f.disabled = 0 AND f.%s != '';",
 			    field, field);
 
   if (!count)
@@ -1133,16 +1167,16 @@
     return -1;
 
   if (idx && qp->filter)
-    query = sqlite3_mprintf("SELECT DISTINCT %s, %s FROM files WHERE data_kind = 0 AND disabled = 0 AND %s != ''"
+    query = sqlite3_mprintf("SELECT DISTINCT f.%s, f.%s FROM files f WHERE f.data_kind = 0 AND f.disabled = 0 AND f.%s != ''"
 			    " AND %s %s;", field, field, field, qp->filter, idx);
   else if (idx)
-    query = sqlite3_mprintf("SELECT DISTINCT %s, %s FROM files WHERE data_kind = 0 AND disabled = 0 AND %s != ''"
+    query = sqlite3_mprintf("SELECT DISTINCT f.%s, f.%s FROM files f WHERE f.data_kind = 0 AND f.disabled = 0 AND f.%s != ''"
 			    " %s;", field, field, field, idx);
   else if (qp->filter)
-    query = sqlite3_mprintf("SELECT DISTINCT %s, %s FROM files WHERE data_kind = 0 AND disabled = 0 AND %s != ''"
+    query = sqlite3_mprintf("SELECT DISTINCT f.%s, f.%s FROM files f WHERE f.data_kind = 0 AND f.disabled = 0 AND f.%s != ''"
 			    " AND %s;", field, field, field, qp->filter);
   else
-    query = sqlite3_mprintf("SELECT DISTINCT %s, %s FROM files WHERE data_kind = 0 AND disabled = 0 AND %s != ''",
+    query = sqlite3_mprintf("SELECT DISTINCT f.%s, f.%s FROM files f WHERE f.data_kind = 0 AND f.disabled = 0 AND f.%s != ''",
 			    field, field, field);
 
   if (!query)
@@ -1510,7 +1544,7 @@
 int
 db_files_get_count(void)
 {
-  return db_get_count("SELECT COUNT(*) FROM files WHERE disabled = 0;");
+  return db_get_count("SELECT COUNT(*) FROM files f WHERE f.disabled = 0;");
 }
 
 void
@@ -1560,14 +1594,14 @@
 }
 
 void
-db_file_ping(char *path)
+db_file_ping(int id)
 {
-#define Q_TMPL "UPDATE files SET db_timestamp = %" PRIi64 ", disabled = 0 WHERE path = '%q';"
+#define Q_TMPL "UPDATE files SET db_timestamp = %" PRIi64 ", disabled = 0 WHERE id = %d;"
   char *query;
   char *errmsg;
   int ret;
 
-  query = sqlite3_mprintf(Q_TMPL, (int64_t)time(NULL), path);
+  query = sqlite3_mprintf(Q_TMPL, (int64_t)time(NULL), id);
   if (!query)
     {
       DPRINTF(E_LOG, L_DB, "Out of memory for query string\n");
@@ -1579,7 +1613,7 @@
 
   ret = db_exec(query, &errmsg);
   if (ret != SQLITE_OK)
-    DPRINTF(E_LOG, L_DB, "Error pinging file '%s': %s\n", path, errmsg);
+    DPRINTF(E_LOG, L_DB, "Error pinging file ID %d: %s\n", id, errmsg);
 
   sqlite3_free(errmsg);
   sqlite3_free(query);
@@ -1590,7 +1624,7 @@
 char *
 db_file_path_byid(int id)
 {
-#define Q_TMPL "SELECT path FROM files WHERE id = %d;"
+#define Q_TMPL "SELECT f.path FROM files f WHERE f.id = %d;"
   char *query;
   sqlite3_stmt *stmt;
   char *res;
@@ -1632,6 +1666,11 @@
   if (res)
     res = strdup(res);
 
+#ifdef DB_PROFILE
+  while (db_blocking_step(stmt) == SQLITE_ROW)
+    ; /* EMPTY */
+#endif
+
   sqlite3_finalize(stmt);
   sqlite3_free(query);
 
@@ -1673,6 +1712,11 @@
 
   ret = sqlite3_column_int(stmt, 0);
 
+#ifdef DB_PROFILE
+  while (db_blocking_step(stmt) == SQLITE_ROW)
+    ; /* EMPTY */
+#endif
+
   sqlite3_finalize(stmt);
 
   return ret;
@@ -1681,7 +1725,7 @@
 int
 db_file_id_bypath(char *path)
 {
-#define Q_TMPL "SELECT id FROM files WHERE path = '%q';"
+#define Q_TMPL "SELECT f.id FROM files f WHERE f.path = '%q';"
   char *query;
   int ret;
 
@@ -1705,7 +1749,7 @@
 int
 db_file_id_byfilebase(char *filename, char *base)
 {
-#define Q_TMPL "SELECT id FROM files WHERE path LIKE '%q/%%/%q';"
+#define Q_TMPL "SELECT f.id FROM files f WHERE f.path LIKE '%q/%%/%q';"
   char *query;
   int ret;
 
@@ -1729,7 +1773,7 @@
 int
 db_file_id_byfile(char *filename)
 {
-#define Q_TMPL "SELECT id FROM files WHERE fname = '%q';"
+#define Q_TMPL "SELECT f.id FROM files f WHERE f.fname = '%q';"
   char *query;
   int ret;
 
@@ -1753,7 +1797,7 @@
 int
 db_file_id_byurl(char *url)
 {
-#define Q_TMPL "SELECT id FROM files WHERE url = '%q';"
+#define Q_TMPL "SELECT f.id FROM files f WHERE f.url = '%q';"
   char *query;
   int ret;
 
@@ -1774,21 +1818,22 @@
 #undef Q_TMPL
 }
 
-time_t
-db_file_stamp_bypath(char *path)
+void
+db_file_stamp_bypath(char *path, time_t *stamp, int *id)
 {
-#define Q_TMPL "SELECT db_timestamp FROM files WHERE path = '%q';"
+#define Q_TMPL "SELECT f.id, f.db_timestamp FROM files f WHERE f.path = '%q';"
   char *query;
   sqlite3_stmt *stmt;
-  time_t stamp;
   int ret;
 
+  *stamp = 0;
+
   query = sqlite3_mprintf(Q_TMPL, path);
   if (!query)
     {
       DPRINTF(E_LOG, L_DB, "Out of memory for query string\n");
 
-      return 0;
+      return;
     }
 
   DPRINTF(E_DBG, L_DB, "Running query '%s'\n", query);
@@ -1799,7 +1844,7 @@
       DPRINTF(E_LOG, L_DB, "Could not prepare statement: %s\n", sqlite3_errmsg(pool_hdl->hdl));
 
       sqlite3_free(query);
-      return 0;
+      return;
     }
 
   ret = db_blocking_step(stmt);
@@ -1812,16 +1857,20 @@
 
       sqlite3_finalize(stmt);
       sqlite3_free(query);
-      return 0;
+      return;
     }
 
-  stamp = (time_t)sqlite3_column_int64(stmt, 0);
+  *id = sqlite3_column_int(stmt, 0);
+  *stamp = (time_t)sqlite3_column_int64(stmt, 1);
+
+#ifdef DB_PROFILE
+  while (db_blocking_step(stmt) == SQLITE_ROW)
+    ; /* EMPTY */
+#endif
 
   sqlite3_finalize(stmt);
   sqlite3_free(query);
 
-  return stamp;
-
 #undef Q_TMPL
 }
 
@@ -1931,6 +1980,11 @@
 	}
     }
 
+#ifdef DB_PROFILE
+  while (db_blocking_step(stmt) == SQLITE_ROW)
+    ; /* EMPTY */
+#endif
+
   sqlite3_finalize(stmt);
 
   return mfi;
@@ -1939,7 +1993,7 @@
 struct media_file_info *
 db_file_fetch_byid(int id)
 {
-#define Q_TMPL "SELECT * FROM files WHERE id = %d;"
+#define Q_TMPL "SELECT f.* FROM files f WHERE f.id = %d;"
   struct media_file_info *mfi;
   char *query;
 
@@ -2245,14 +2299,14 @@
 int
 db_pl_get_count(void)
 {
-  return db_get_count("SELECT COUNT(*) FROM playlists WHERE disabled = 0;");
+  return db_get_count("SELECT COUNT(*) FROM playlists p WHERE p.disabled = 0;");
 }
 
 static int
 db_pl_count_items(int id)
 {
-#define Q_TMPL "SELECT COUNT(*) FROM playlistitems JOIN files" \
-               " ON playlistitems.filepath = files.path WHERE files.disabled = 0 AND playlistitems.playlistid = %d;"
+#define Q_TMPL "SELECT COUNT(*) FROM playlistitems pi JOIN files f" \
+               " ON pi.filepath = f.path WHERE f.disabled = 0 AND pi.playlistid = %d;"
   char *query;
   int ret;
 
@@ -2276,7 +2330,7 @@
 static int
 db_smartpl_count_items(const char *smartpl_query)
 {
-#define Q_TMPL "SELECT COUNT(*) FROM files WHERE disabled = 0 AND %s;"
+#define Q_TMPL "SELECT COUNT(*) FROM files f WHERE f.disabled = 0 AND %s;"
   char *query;
   int ret;
 
@@ -2328,7 +2382,7 @@
 static int
 db_pl_id_bypath(char *path, int *id)
 {
-#define Q_TMPL "SELECT id FROM playlists WHERE path = '%q';"
+#define Q_TMPL "SELECT p.id FROM playlists p WHERE p.path = '%q';"
   char *query;
   sqlite3_stmt *stmt;
   int ret;
@@ -2367,6 +2421,11 @@
 
   *id = sqlite3_column_int(stmt, 0);
 
+#ifdef DB_PROFILE
+  while (db_blocking_step(stmt) == SQLITE_ROW)
+    ; /* EMPTY */
+#endif
+
   sqlite3_finalize(stmt);
   sqlite3_free(query);
 
@@ -2501,7 +2560,7 @@
 struct playlist_info *
 db_pl_fetch_bypath(char *path)
 {
-#define Q_TMPL "SELECT * FROM playlists WHERE path = '%q';"
+#define Q_TMPL "SELECT p.* FROM playlists p WHERE p.path = '%q';"
   struct playlist_info *pli;
   char *query;
 
@@ -2525,7 +2584,7 @@
 struct playlist_info *
 db_pl_fetch_byid(int id)
 {
-#define Q_TMPL "SELECT * FROM playlists WHERE id = %d;"
+#define Q_TMPL "SELECT p.* FROM playlists p WHERE p.id = %d;"
   struct playlist_info *pli;
   char *query;
 
@@ -2549,7 +2608,7 @@
 struct playlist_info *
 db_pl_fetch_bytitlepath(char *title, char *path)
 {
-#define Q_TMPL "SELECT * FROM playlists WHERE title = '%q' AND path = '%q';"
+#define Q_TMPL "SELECT p.* FROM playlists p WHERE p.title = '%q' AND p.path = '%q';"
   struct playlist_info *pli;
   char *query;
 
@@ -2573,7 +2632,7 @@
 int
 db_pl_add(char *title, char *path, int *id)
 {
-#define QDUP_TMPL "SELECT COUNT(*) FROM playlists WHERE title = '%q' AND path = '%q';"
+#define QDUP_TMPL "SELECT COUNT(*) FROM playlists p WHERE p.title = '%q' AND p.path = '%q';"
 #define QADD_TMPL "INSERT INTO playlists (title, type, query, db_timestamp, disabled, path, idx, special_id)" \
                   " VALUES ('%q', 0, NULL, %" PRIi64 ", 0, '%q', 0, 0);"
   char *query;
@@ -2672,7 +2731,7 @@
 int
 db_pl_add_item_byid(int plid, int fileid)
 {
-#define Q_TMPL "INSERT INTO playlistitems (playlistid, filepath) VALUES (%d, (SELECT path FROM files WHERE id = %d));"
+#define Q_TMPL "INSERT INTO playlistitems (playlistid, filepath) VALUES (%d, (SELECT f.path FROM files f WHERE f.id = %d));"
   char *query;
   char *errmsg;
   int ret;
@@ -2905,7 +2964,7 @@
 enum group_type
 db_group_type_byid(int id)
 {
-#define Q_TMPL "SELECT type FROM groups WHERE id = '%d';"
+#define Q_TMPL "SELECT g.type FROM groups g WHERE g.id = '%d';"
   char *query;
   sqlite3_stmt *stmt;
   int ret;
@@ -2944,6 +3003,11 @@
 
   ret = sqlite3_column_int(stmt, 0);
 
+#ifdef DB_PROFILE
+  while (db_blocking_step(stmt) == SQLITE_ROW)
+    ; /* EMPTY */
+#endif
+
   sqlite3_finalize(stmt);
   sqlite3_free(query);
 
@@ -3030,7 +3094,7 @@
 int
 db_pairing_fetch_byguid(struct pairing_info *pi)
 {
-#define Q_TMPL "SELECT * FROM pairings WHERE guid = '%q';"
+#define Q_TMPL "SELECT p.* FROM pairings p WHERE p.guid = '%q';"
   char *query;
   sqlite3_stmt *stmt;
   int ret;
@@ -3067,6 +3131,11 @@
   pi->remote_id = strdup((char *)sqlite3_column_text(stmt, 0));
   pi->name = strdup((char *)sqlite3_column_text(stmt, 1));
 
+#ifdef DB_PROFILE
+  while (db_blocking_step(stmt) == SQLITE_ROW)
+    ; /* EMPTY */
+#endif
+
   sqlite3_finalize(stmt);
   sqlite3_free(query);
 
@@ -3116,7 +3185,7 @@
 int
 db_speaker_get(uint64_t id, int *selected, int *volume)
 {
-#define Q_TMPL "SELECT selected, volume FROM speakers WHERE id = %" PRIi64 ";"
+#define Q_TMPL "SELECT s.selected, s.volume FROM speakers s WHERE s.id = %" PRIi64 ";"
   sqlite3_stmt *stmt;
   char *query;
   int ret;
@@ -3155,6 +3224,11 @@
   *selected = sqlite3_column_int(stmt, 0);
   *volume = sqlite3_column_int(stmt, 1);
 
+#ifdef DB_PROFILE
+  while (db_blocking_step(stmt) == SQLITE_ROW)
+    ; /* EMPTY */
+#endif
+
   sqlite3_finalize(stmt);
 
   ret = 0;
@@ -3445,6 +3519,11 @@
 	}
     }
 
+#ifdef DB_PROFILE
+  while (db_blocking_step(stmt) == SQLITE_ROW)
+    ; /* EMPTY */
+#endif
+
   sqlite3_finalize(stmt);
   sqlite3_free(query);
 
@@ -3669,8 +3748,57 @@
 static void
 db_xprofile(void *notused, const char *pquery, sqlite3_uint64 ptime)
 {
-  DPRINTF(E_DBG, L_DB, "SQL PROFILE query: %s\n", pquery);
-  DPRINTF(E_DBG, L_DB, "SQL PROFILE time: %" PRIu64 "\n", (uint64_t)ptime); 
+  sqlite3_stmt *stmt;
+  char *query;
+  int ret;
+
+  DPRINTF(E_DBG, L_DBPERF, "SQL PROFILE query: %s\n", pquery);
+  DPRINTF(E_DBG, L_DBPERF, "SQL PROFILE time: %" PRIu64 " ms\n", ((uint64_t)ptime / 1000000));
+
+  if ((strncmp(pquery, "SELECT", 6) != 0)
+       && (strncmp(pquery, "UPDATE", 6) != 0)
+       && (strncmp(pquery, "DELETE", 6) != 0))
+      return;
+
+  /* Disable profiling callback */
+  sqlite3_profile(pool_hdl->hdl, NULL, NULL);
+
+  query = sqlite3_mprintf("EXPLAIN QUERY PLAN %s", pquery);
+  if (!query)
+    {
+      DPRINTF(E_DBG, L_DBPERF, "Query plan: Out of memory\n");
+
+      goto out;
+    }
+
+  ret = db_blocking_prepare_v2(query, -1, &stmt, NULL);
+  sqlite3_free(query);
+  if (ret != SQLITE_OK)
+    {
+      DPRINTF(E_DBG, L_DBPERF, "Query plan: Could not prepare statement: %s\n", sqlite3_errmsg(pool_hdl->hdl));
+
+      goto out;
+    }
+
+  DPRINTF(E_DBG, L_DBPERF, "Query plan:\n");
+
+  while ((ret = db_blocking_step(stmt)) == SQLITE_ROW)
+    {
+      DPRINTF(E_DBG, L_DBPERF, "(%d,%d,%d) %s\n",
+	      sqlite3_column_int(stmt, 0), sqlite3_column_int(stmt, 1), sqlite3_column_int(stmt, 2),
+	      sqlite3_column_text(stmt, 3));
+    }
+
+  if (ret != SQLITE_DONE)
+    DPRINTF(E_DBG, L_DBPERF, "Query plan: Could not step: %s\n", sqlite3_errmsg(pool_hdl->hdl));
+
+  DPRINTF(E_DBG, L_DBPERF, "---\n");
+
+  sqlite3_finalize(stmt);
+
+ out:
+  /* Reenable profiling callback */
+  sqlite3_profile(pool_hdl->hdl, db_xprofile, NULL);
 }
 #endif
 
@@ -4161,8 +4289,35 @@
   "   path        VARCHAR(4096) NOT NULL"		\
   ");"
 
-#define I_PATH							\
-  "CREATE INDEX IF NOT EXISTS idx_path ON files(path, idx);"
+#define I_RESCAN				\
+  "CREATE INDEX IF NOT EXISTS idx_rescan ON files(path, db_timestamp);"
+
+#define I_SONGALBUMID				\
+  "CREATE INDEX IF NOT EXISTS idx_sai ON files(songalbumid);"
+
+#define I_STATEMKINDSAI				\
+  "CREATE INDEX IF NOT EXISTS idx_state_mkind_sai ON files(disabled, media_kind, songalbumid);"
+
+#define I_ARTIST				\
+  "CREATE INDEX IF NOT EXISTS idx_artist ON files(artist, artist_sort);"
+
+#define I_ALBUMARTIST				\
+  "CREATE INDEX IF NOT EXISTS idx_albumartist ON files(album_artist, album_artist_sort);"
+
+#define I_COMPOSER				\
+  "CREATE INDEX IF NOT EXISTS idx_composer ON files(composer, composer_sort);"
+
+#define I_TITLE					\
+  "CREATE INDEX IF NOT EXISTS idx_title ON files(title, title_sort);"
+
+#define I_ALBUM					\
+  "CREATE INDEX IF NOT EXISTS idx_album ON files(album, album_sort);"
+
+#define I_PL_PATH				\
+  "CREATE INDEX IF NOT EXISTS idx_pl_path ON playlists(path);"
+
+#define I_PL_DISABLED				\
+  "CREATE INDEX IF NOT EXISTS idx_pl_disabled ON playlists(disabled);"
 
 #define I_FILEPATH							\
   "CREATE INDEX IF NOT EXISTS idx_filepath ON playlistitems(filepath ASC);"
@@ -4170,17 +4325,12 @@
 #define I_PLITEMID							\
   "CREATE INDEX IF NOT EXISTS idx_playlistid ON playlistitems(playlistid, filepath);"
 
+#define I_GRP_TYPE_PERSIST				\
+  "CREATE INDEX IF NOT EXISTS idx_grp_type_persist ON groups(type, persistentid);"
+
 #define I_PAIRING				\
   "CREATE INDEX IF NOT EXISTS idx_pairingguid ON pairings(guid);"
 
-#define I_TITLESORT				\
-  "CREATE INDEX IF NOT EXISTS idx_titlesort ON files(title_sort);"
-
-#define I_ARTISTSORT				\
-  "CREATE INDEX IF NOT EXISTS idx_artistsort ON files(artist_sort);"
-
-#define I_ALBUMSORT				\
-  "CREATE INDEX IF NOT EXISTS idx_albumsort ON files(album_sort);"
 
 #define TRG_GROUPS_INSERT_FILES						\
   "CREATE TRIGGER update_groups_new_file AFTER INSERT ON files FOR EACH ROW" \
@@ -4200,15 +4350,15 @@
 
 #define Q_PL2								\
   "INSERT INTO playlists (id, title, type, query, db_timestamp, path, idx, special_id)" \
-  " VALUES(2, 'Music', 1, 'media_kind = 1', 0, '', 0, 6);"
+  " VALUES(2, 'Music', 1, 'f.media_kind = 1', 0, '', 0, 6);"
 
 #define Q_PL3								\
   "INSERT INTO playlists (id, title, type, query, db_timestamp, path, idx, special_id)" \
-  " VALUES(3, 'Movies', 1, 'media_kind = 2', 0, '', 0, 4);"
+  " VALUES(3, 'Movies', 1, 'f.media_kind = 2', 0, '', 0, 4);"
 
 #define Q_PL4								\
   "INSERT INTO playlists (id, title, type, query, db_timestamp, path, idx, special_id)" \
-  " VALUES(4, 'TV Shows', 1, 'media_kind = 64', 0, '', 0, 5);"
+  " VALUES(4, 'TV Shows', 1, 'f.media_kind = 64', 0, '', 0, 5);"
 
 /* These are the remaining automatically-created iTunes playlists, but
  * their query is unknown
@@ -4218,9 +4368,9 @@
   " VALUES(8, 'Purchased', 0, 'media_kind = 1024', 0, '', 0, 8);"
  */
 
-#define SCHEMA_VERSION 12
+#define SCHEMA_VERSION 13
 #define Q_SCVER					\
-  "INSERT INTO admin (key, value) VALUES ('schema_version', '12');"
+  "INSERT INTO admin (key, value) VALUES ('schema_version', '13');"
 
 struct db_init_query {
   char *query;
@@ -4238,13 +4388,25 @@
     { T_SPEAKERS,  "create table speakers" },
     { T_INOTIFY,   "create table inotify" },
 
-    { I_PATH,      "create file path index" },
+    { I_RESCAN,    "create rescan index" },
+    { I_SONGALBUMID, "create songalbumid index" },
+    { I_STATEMKINDSAI, "create state/mkind/sai index" },
+
+    { I_ARTIST,    "create artist index" },
+    { I_ALBUMARTIST, "create album_artist index" },
+    { I_COMPOSER,  "create composer index" },
+    { I_TITLE,     "create title index" },
+    { I_ALBUM,     "create album index" },
+
+    { I_PL_PATH,   "create playlist path index" },
+    { I_PL_DISABLED, "create playlist state index" },
+
     { I_FILEPATH,  "create file path index" },
     { I_PLITEMID,  "create playlist id index" },
+
+    { I_GRP_TYPE_PERSIST, "create groups type/persistentid index" },
+
     { I_PAIRING,   "create pairing guid index" },
-    { I_TITLESORT, "create file titlesort index" },
-    { I_ARTISTSORT,"create file artistsort index" },
-    { I_ALBUMSORT, "create file albumsort index" },
 
     { TRG_GROUPS_INSERT_FILES,    "create trigger update_groups_new_file" },
     { TRG_GROUPS_UPDATE_FILES,    "create trigger update_groups_update_file" },
@@ -4784,6 +4946,92 @@
 #undef Q_DUMP
 }
 
+/* Upgrade from schema v12 to v13 */
+
+#define U_V13_DROP_IDX_PATH						\
+  "DROP INDEX idx_path;"
+
+#define U_V13_DROP_IDX_TS						\
+  "DROP INDEX idx_titlesort;"
+
+#define U_V13_DROP_IDX_AS						\
+  "DROP INDEX idx_artistsort;"
+
+#define U_V13_DROP_IDX_BS						\
+  "DROP INDEX idx_albumsort;"
+
+#define U_V13_IDX_RESCAN						\
+  "CREATE INDEX IF NOT EXISTS idx_rescan ON files(path, db_timestamp);"
+
+#define U_V13_IDX_SONGALBUMID					\
+  "CREATE INDEX IF NOT EXISTS idx_sai ON files(songalbumid);"
+
+#define U_V13_IDX_STATEMKINDSAI						\
+  "CREATE INDEX IF NOT EXISTS idx_state_mkind_sai ON files(disabled, media_kind, songalbumid);"
+
+#define U_V13_IDX_ARTIST				\
+  "CREATE INDEX IF NOT EXISTS idx_artist ON files(artist, artist_sort);"
+
+#define U_V13_IDX_ALBUMARTIST				\
+  "CREATE INDEX IF NOT EXISTS idx_albumartist ON files(album_artist, album_artist_sort);"
+
+#define U_V13_IDX_COMPOSER				\
+  "CREATE INDEX IF NOT EXISTS idx_composer ON files(composer, composer_sort);"
+
+#define U_V13_IDX_TITLE					\
+  "CREATE INDEX IF NOT EXISTS idx_title ON files(title, title_sort);"
+
+#define U_V13_IDX_ALBUM					\
+  "CREATE INDEX IF NOT EXISTS idx_album ON files(album, album_sort);"
+
+#define U_V13_IDX_GRP_TYPE_PERSIST					\
+  "CREATE INDEX IF NOT EXISTS idx_grp_type_persist ON groups(type, persistentid);"
+
+#define U_V13_IDX_PL_PATH				\
+  "CREATE INDEX IF NOT EXISTS idx_pl_path ON playlists(path);"
+
+#define U_V13_IDX_PL_DISABLED				\
+  "CREATE INDEX IF NOT EXISTS idx_pl_disabled ON playlists(disabled);"
+
+#define U_V13_PL2							\
+  "UPDATE playlists SET query = 'f.media_kind = 1' where id = 2;"
+
+#define U_V13_PL3							\
+  "UPDATE playlists SET query = 'f.media_kind = 2' where id = 3;"
+
+#define U_V13_PL4							\
+  "UPDATE playlists SET query = 'f.media_kind = 64' where id = 4;"
+
+#define U_V13_SCVER				\
+  "UPDATE admin SET value = '13' WHERE key = 'schema_version';"
+
+static const struct db_init_query db_upgrade_v13_queries[] =
+  {
+    { U_V13_DROP_IDX_PATH, "drop index path table files" },
+    { U_V13_DROP_IDX_TS,   "drop index titlesort table files" },
+    { U_V13_DROP_IDX_AS,   "drop index artistsort table files" },
+    { U_V13_DROP_IDX_BS,   "drop index albumsort table files" },
+
+    { U_V13_IDX_RESCAN,    "create rescan index" },
+    { U_V13_IDX_SONGALBUMID, "create songalbumid index" },
+    { U_V13_IDX_STATEMKINDSAI, "create state/mkind/sai index" },
+    { U_V13_IDX_ARTIST,    "create artist index" },
+    { U_V13_IDX_ALBUMARTIST, "create album_artist index" },
+    { U_V13_IDX_COMPOSER,  "create composer index" },
+    { U_V13_IDX_TITLE,     "create title index" },
+    { U_V13_IDX_ALBUM,     "create album index" },
+
+    { U_V13_IDX_GRP_TYPE_PERSIST, "create groups type/persistentid index" },
+
+    { U_V13_IDX_PL_PATH,   "create playlist path index" },
+    { U_V13_IDX_PL_DISABLED, "create playlist state index" },
+
+    { U_V13_PL2,           "update default smart playlist 'Music'" },
+    { U_V13_PL3,           "update default smart playlist 'Movies'" },
+    { U_V13_PL4,           "update default smart playlist 'TV Shows'" },
+
+    { U_V13_SCVER,    "set schema_version to 13" },
+  };
 
 static int
 db_check_version(void)
@@ -4849,6 +5097,13 @@
 	    if (ret < 0)
 	      return -1;
 
+	    /* FALLTHROUGH */
+
+	  case 12:
+	    ret = db_generic_upgrade(db_upgrade_v13_queries, sizeof(db_upgrade_v13_queries) / sizeof(db_upgrade_v13_queries[0]));
+	    if (ret < 0)
+	      return -1;
+
 	    break;
 
 	  default:
@@ -4937,6 +5192,8 @@
 	}
     }
 
+  db_analyze();
+
   files = db_files_get_count();
   pls = db_pl_get_count();
 

=== modified file 'src/db.h'
--- src/db.h	2011-06-20 18:15:23 +0000
+++ src/db.h	2011-09-11 16:19:40 +0000
@@ -286,6 +286,10 @@
 void
 free_pli(struct playlist_info *pli, int content_only);
 
+/* Maintenance and DB hygiene */
+void
+db_hook_post_scan(void);
+
 void
 db_purge_cruft(time_t ref);
 
@@ -322,7 +326,7 @@
 db_file_inc_playcount(int id);
 
 void
-db_file_ping(char *path);
+db_file_ping(int id);
 
 char *
 db_file_path_byid(int id);
@@ -339,8 +343,8 @@
 int
 db_file_id_byurl(char *url);
 
-time_t
-db_file_stamp_bypath(char *path);
+void
+db_file_stamp_bypath(char *path, time_t *stamp, int *id);
 
 struct media_file_info *
 db_file_fetch_byid(int id);

=== modified file 'src/filescanner.c'
--- src/filescanner.c	2011-06-20 18:15:23 +0000
+++ src/filescanner.c	2011-09-11 16:19:40 +0000
@@ -284,13 +284,14 @@
   char *filename;
   char *ext;
   time_t stamp;
+  int id;
   int ret;
 
-  stamp = db_file_stamp_bypath(file);
+  db_file_stamp_bypath(file, &stamp, &id);
 
   if (stamp >= mtime)
     {
-      db_file_ping(file);
+      db_file_ping(id);
       return;
     }
 
@@ -787,6 +788,8 @@
 					   DPRINTF(E_DBG, L_SCAN, "Purging old database content\n");
 					   db_purge_cruft(start);
 
+					   db_hook_post_scan();
+
 					   db_pool_release();
 
 					   dispatch_group_leave(scanner_grp);

=== modified file 'src/filescanner_ffmpeg.c'
--- src/filescanner_ffmpeg.c	2011-06-20 17:59:55 +0000
+++ src/filescanner_ffmpeg.c	2011-09-11 15:51:59 +0000
@@ -203,9 +203,17 @@
 
 
 static int
+#if LIBAVUTIL_VERSION_MAJOR >= 51 || (LIBAVUTIL_VERSION_MAJOR == 51 && LIBAVUTIL_VERSION_MINOR >= 5)
+extract_metadata_core(struct media_file_info *mfi, AVDictionary *md, const struct metadata_map *md_map)
+#else
 extract_metadata_core(struct media_file_info *mfi, AVMetadata *md, const struct metadata_map *md_map)
+#endif
 {
+#if LIBAVUTIL_VERSION_MAJOR >= 51 || (LIBAVUTIL_VERSION_MAJOR == 51 && LIBAVUTIL_VERSION_MINOR >= 5)
+  AVDictionaryEntry *mdt;
+#else
   AVMetadataTag *mdt;
+#endif
   char **strval;
   uint32_t *intval;
   int mdcount;
@@ -215,7 +223,11 @@
 #if 0
   /* Dump all the metadata reported by ffmpeg */
   mdt = NULL;
+#if LIBAVUTIL_VERSION_MAJOR >= 51 || (LIBAVUTIL_VERSION_MAJOR == 51 && LIBAVUTIL_VERSION_MINOR >= 5)
+  while ((mdt = av_dict_get(md, "", mdt, AV_DICT_IGNORE_SUFFIX)) != NULL)
+#else
   while ((mdt = av_metadata_get(md, "", mdt, AV_METADATA_IGNORE_SUFFIX)) != NULL)
+#endif
     fprintf(stderr, " -> %s = %s\n", mdt->key, mdt->value);
 #endif
 
@@ -224,7 +236,11 @@
   /* Extract actual metadata */
   for (i = 0; md_map[i].key != NULL; i++)
     {
+#if LIBAVUTIL_VERSION_MAJOR >= 51 || (LIBAVUTIL_VERSION_MAJOR == 51 && LIBAVUTIL_VERSION_MINOR >= 5)
+      mdt = av_dict_get(md, md_map[i].key, NULL, 0);
+#else
       mdt = av_metadata_get(md, md_map[i].key, NULL, 0);
+#endif
       if (mdt == NULL)
 	continue;
 
@@ -311,7 +327,13 @@
   int i;
   int ret;
 
+  ctx = NULL;
+
+#if LIBAVFORMAT_VERSION_MAJOR >= 53 || (LIBAVFORMAT_VERSION_MAJOR == 53 && LIBAVCODEC_VERSION_MINOR >= 3)
+  ret = avformat_open_input(&ctx, file, NULL, NULL);
+#else
   ret = av_open_input_file(&ctx, file, NULL, 0, NULL);
+#endif
   if (ret != 0)
     {
       DPRINTF(E_WARN, L_SCAN, "Cannot open media file '%s': %s\n", file, strerror(AVUNERROR(ret)));
@@ -330,7 +352,11 @@
 
 #if 0
   /* Dump input format as determined by ffmpeg */
+# if LIBAVFORMAT_VERSION_MAJOR >= 52 || (LIBAVFORMAT_VERSION_MAJOR == 52 && LIBAVCODEC_VERSION_MINOR >= 101)
+  av_dump_format(ctx, 0, file, 0);
+# else
   dump_format(ctx, 0, file, FALSE);
+# endif
 #endif
 
   DPRINTF(E_DBG, L_SCAN, "File has %d streams\n", ctx->nb_streams);
@@ -404,7 +430,9 @@
 	mfi->samplerate = audio_stream->codec->sample_rate;
 
       /* Try sample format first */
-#if LIBAVCODEC_VERSION_MAJOR >= 53
+#if LIBAVUTIL_VERSION_MAJOR >= 51 || (LIBAVUTIL_VERSION_MAJOR == 51 && LIBAVUTIL_VERSION_MINOR >= 4)
+      mfi->bits_per_sample = 8 * av_get_bytes_per_sample(audio_stream->codec->sample_fmt);
+#elif LIBAVCODEC_VERSION_MAJOR >= 53
       mfi->bits_per_sample = av_get_bits_per_sample_fmt(audio_stream->codec->sample_fmt);
 #else
       mfi->bits_per_sample = av_get_bits_per_sample_format(audio_stream->codec->sample_fmt);

=== modified file 'src/httpd_daap.c'
--- src/httpd_daap.c	2011-06-20 18:15:23 +0000
+++ src/httpd_daap.c	2011-09-11 16:19:40 +0000
@@ -58,6 +58,8 @@
 
 /* Session timeout in seconds */
 #define DAAP_SESSION_TIMEOUT 1800
+/* Update requests refresh interval in seconds */
+#define DAAP_UPDATE_REFRESH  300
 
 
 struct uri_map {
@@ -77,6 +79,9 @@
   struct http_request *req;
   struct http_response *r;
 
+  /* Refresh tiemout */
+  dispatch_source_t timeout;
+
   struct daap_update_request *next;
 };
 
@@ -100,6 +105,7 @@
 static int next_session_id;
 
 /* Update requests */
+static int current_rev;
 static dispatch_queue_t updates_sq;
 static struct daap_update_request *update_requests;
 
@@ -128,10 +134,8 @@
 
   s = (struct daap_session *)item;
 
-#if 0
   dispatch_source_cancel(s->timeout);
   dispatch_release(s->timeout);
-#endif /* 0 */
   free(s);
 }
 
@@ -147,7 +151,6 @@
       });
 }
 
-#if 0
 /* Queue: sessions_sq */
 static void
 daap_session_timeout_cb(void *arg)
@@ -160,7 +163,6 @@
 
   daap_session_kill(s);
 }
-#endif /* 0 */
 
 /* Queue: HTTP read queue */
 static struct daap_session *
@@ -179,7 +181,6 @@
 
   memset(s, 0, sizeof(struct daap_session));
 
-#if 0
   s->timeout = dispatch_source_create(DISPATCH_SOURCE_TYPE_TIMER, 0, 0, sessions_sq);
   if (!s->timeout)
     {
@@ -195,7 +196,6 @@
   dispatch_source_set_timer(s->timeout,
 			    dispatch_time(DISPATCH_TIME_NOW, DAAP_SESSION_TIMEOUT * NSEC_PER_SEC),
 			    DISPATCH_TIME_FOREVER /* one-shot */, 30 * NSEC_PER_SEC);
-#endif /* 0 */
 
   dispatch_sync(sessions_sq, ^{
       avl_node_t *node;
@@ -213,9 +213,7 @@
 	  return;
 	}
 
-#if 0
       dispatch_resume(s->timeout);
-#endif
 
       b_ret = 0;
     });
@@ -265,11 +263,9 @@
 
       *s = (struct daap_session *)node->item;
 
-#if 0
       dispatch_source_set_timer((*s)->timeout,
 				dispatch_time(DISPATCH_TIME_NOW, DAAP_SESSION_TIMEOUT * NSEC_PER_SEC),
 				DISPATCH_TIME_FOREVER /* one-shot */, 30 * NSEC_PER_SEC);
-#endif /* 0 */
     });
 
   if (!*s)
@@ -285,13 +281,10 @@
 /* Update requests helpers */
 /* Queue: updates_sq */
 static void
-update_free_cb_task(void *arg)
+update_remove(struct daap_update_request *ur)
 {
-  struct daap_update_request *ur;
   struct daap_update_request *p;
 
-  ur = (struct daap_update_request *)arg;
-
   if (ur == update_requests)
     update_requests = ur->next;
   else
@@ -307,10 +300,83 @@
 
       p->next = ur->next;
     }
+}
+
+static void
+update_free(struct daap_update_request *ur)
+{
+  dispatch_source_cancel(ur->timeout);
+  dispatch_release(ur->timeout);
 
   free(ur);
 }
 
+/* Queue: updates_sq */
+static void
+update_refresh_cb(void *arg)
+{
+  struct daap_update_request *ur;
+  struct evbuffer *evbuf;
+  int ret;
+
+  ur = (struct daap_update_request *)arg;
+
+  evbuf = evbuffer_new();
+  if (!evbuf)
+    {
+      DPRINTF(E_LOG, L_DAAP, "Could not allocate evbuffer for DAAP update data\n");
+
+      return;
+    }
+
+  ret = evbuffer_expand(evbuf, 32);
+  if (ret < 0)
+    {
+      DPRINTF(E_LOG, L_DAAP, "Could not expand evbuffer for DAAP update data\n");
+
+      return;
+    }
+
+  /* Send back current revision */
+  dmap_add_container(evbuf, "mupd", 24);
+  dmap_add_int(evbuf, "mstt", 200);         /* 12 */
+  dmap_add_int(evbuf, "musr", current_rev); /* 12 */
+
+  ret = http_response_set_status(ur->r, HTTP_OK, "OK");
+  if (ret < 0)
+    {
+      DPRINTF(E_LOG, L_DAAP, "Could not set response status for DAAP update\n");
+
+      evbuffer_free(evbuf);
+      return;
+    }
+
+  http_response_set_body(ur->r, evbuf);
+
+  ret = http_server_response_thaw_and_run(ur->c, ur->r);
+  if (ret < 0)
+    {
+      DPRINTF(E_LOG, L_DAAP, "Could not thaw and run response to DAAP update request\n");
+
+      http_server_kill_connection(ur->c);
+    }
+
+  update_remove(ur);
+  update_free(ur);
+}
+
+/* Queue: updates_sq */
+static void
+update_free_cb_task(void *arg)
+{
+  struct daap_update_request *ur;
+
+  ur = (struct daap_update_request *)arg;
+
+  update_remove(ur);
+  update_free(ur);
+}
+
 static void
 update_free_cb(void *data)
 {
@@ -638,7 +704,7 @@
   passwd = cfg_getstr(lib, "password");
   name = cfg_getstr(lib, "name");
 
-  len = 136 + strlen(name);
+  len = 157 + strlen(name);
 
   ret = evbuffer_expand(evbuf, len);
   if (ret < 0)
@@ -673,10 +739,8 @@
   dmap_add_int(evbuf, "apro", apro); /* 12 */
   dmap_add_string(evbuf, "minm", name); /* 8 + strlen(name) */
 
-#if 0
   dmap_add_int(evbuf, "mstm", DAAP_SESSION_TIMEOUT); /* 12 */
   dmap_add_char(evbuf, "msal", 1);   /* 9 */
-#endif
 
   dmap_add_char(evbuf, "mslr", 1);   /* 9 */
   dmap_add_char(evbuf, "msau", (passwd) ? 2 : 0); /* 9 */
@@ -859,7 +923,6 @@
   struct daap_session *s;
   struct daap_update_request *ur;
   const char *param;
-  int current_rev = 2;
   int reqd_rev;
   int ret;
 
@@ -923,6 +986,23 @@
 
       return dmap_send_error(h, "mupd", "Out of memory");
     }
+  memset(ur, 0, sizeof(struct daap_update_request));
+
+  ur->timeout = dispatch_source_create(DISPATCH_SOURCE_TYPE_TIMER, 0, 0, updates_sq);
+  if (!ur->timeout)
+    {
+      DPRINTF(E_LOG, L_DAAP, "Could not create dispatch source for update timeout\n");
+
+      free(ur);
+      return dmap_send_error(h, "mupd", "Could not create timer");
+    }
+
+  dispatch_set_context(ur->timeout, ur);
+  dispatch_source_set_event_handler_f(ur->timeout, update_refresh_cb);
+
+  dispatch_source_set_timer(ur->timeout,
+			    dispatch_time(DISPATCH_TIME_NOW, DAAP_UPDATE_REFRESH * NSEC_PER_SEC),
+			    DISPATCH_TIME_FOREVER /* one-shot */, 30 * NSEC_PER_SEC);
 
   /* Freeze the request */
   http_server_response_freeze(h->c, h->r, update_free_cb, ur);
@@ -935,6 +1015,8 @@
   dispatch_sync(updates_sq, ^{
       ur->next = update_requests;
       update_requests = ur;
+
+      dispatch_resume(ur->timeout);
     });
 
   return 0;
@@ -2663,6 +2745,7 @@
   int ret;
 
   next_session_id = 100; /* gotta start somewhere, right? */
+  current_rev = 2;
   update_requests = NULL;
 
   sessions_sq = dispatch_queue_create("org.forked-daapd.daap.sessions", NULL);

=== modified file 'src/httpd_dacp.c'
--- src/httpd_dacp.c	2011-06-20 18:15:23 +0000
+++ src/httpd_dacp.c	2011-09-11 16:19:40 +0000
@@ -1434,16 +1434,15 @@
   while (prop)
     {
       dpm = dacp_find_prop(prop, strlen(prop));
-      if (!dpm)
+      if (dpm)
 	{
-	  DPRINTF(E_LOG, L_DACP, "Could not find requested property '%s'\n", prop);
-	  continue;
+	  if (dpm->propget)
+	    dpm->propget(proplist, &status, mfi);
+	  else
+	    DPRINTF(E_WARN, L_DACP, "No getter method for DACP property %s\n", prop);
 	}
-
-      if (dpm->propget)
-	dpm->propget(proplist, &status, mfi);
       else
-	DPRINTF(E_WARN, L_DACP, "No getter method for DACP property %s\n", prop);
+	DPRINTF(E_LOG, L_DACP, "Could not find requested property '%s'\n", prop);
 
       prop = strtok_r(NULL, ",", &ptr);
     }

=== modified file 'src/logger.c'
--- src/logger.c	2011-08-07 12:16:39 +0000
+++ src/logger.c	2011-09-11 16:19:40 +0000
@@ -43,7 +43,7 @@
 static int console;
 static char *logfilename;
 static FILE *logfile;
-static char *labels[] = { "config", "daap", "db", "httpd", "main", "mdns", "misc", "rsp", "scan", "xcode", "-free-", "remote", "dacp", "ffmpeg", "artwork", "player", "raop", "laudio", "dmap", "http" };
+static char *labels[] = { "config", "daap", "db", "httpd", "main", "mdns", "misc", "rsp", "scan", "xcode", "-free-", "remote", "dacp", "ffmpeg", "artwork", "player", "raop", "laudio", "dmap", "dbperf", "http" };
 
 
 static int

=== modified file 'src/logger.h'
--- src/logger.h	2011-06-20 18:15:23 +0000
+++ src/logger.h	2011-09-11 16:19:40 +0000
@@ -24,9 +24,10 @@
 #define L_RAOP    16
 #define L_LAUDIO  17
 #define L_DMAP    18
-#define L_HTTP    19
+#define L_DBPERF  19
+#define L_HTTP    20
 
-#define N_LOGDOMAINS  20
+#define N_LOGDOMAINS  21
 
 /* Severities */
 #define E_FATAL   0

=== modified file 'src/pregen/DAAP2SQL.c'
--- src/pregen/DAAP2SQL.c	2011-08-07 12:16:39 +0000
+++ src/pregen/DAAP2SQL.c	2011-09-11 16:19:40 +0000
@@ -2,7 +2,7 @@
  *  This C source file was generated by $ANTLR version 3.2 debian-5
  *
  *     -  From the grammar source file : DAAP2SQL.g
- *     -                            On : 2011-08-07 12:11:34
+ *     -                            On : 2011-09-11 16:17:21
  *     -           for the tree parser : DAAP2SQLTreeParser *
  * Editing it, at least manually, is not wise. 
  *

=== modified file 'src/pregen/DAAP2SQL.h'
--- src/pregen/DAAP2SQL.h	2011-08-07 12:16:39 +0000
+++ src/pregen/DAAP2SQL.h	2011-09-11 16:19:40 +0000
@@ -2,7 +2,7 @@
  *  This C header file was generated by $ANTLR version 3.2 debian-5
  *
  *     -  From the grammar source file : DAAP2SQL.g
- *     -                            On : 2011-08-07 12:11:34
+ *     -                            On : 2011-09-11 16:17:21
  *     -           for the tree parser : DAAP2SQLTreeParser *
  * Editing it, at least manually, is not wise. 
  *

=== modified file 'src/pregen/DAAPLexer.c'
--- src/pregen/DAAPLexer.c	2011-08-07 12:16:39 +0000
+++ src/pregen/DAAPLexer.c	2011-09-11 16:19:40 +0000
@@ -2,7 +2,7 @@
  *  This C source file was generated by $ANTLR version 3.2 debian-5
  *
  *     -  From the grammar source file : DAAP.g
- *     -                            On : 2011-08-07 12:11:34
+ *     -                            On : 2011-09-11 16:17:21
  *     -                 for the lexer : DAAPLexerLexer *
  * Editing it, at least manually, is not wise. 
  *

=== modified file 'src/pregen/DAAPLexer.h'
--- src/pregen/DAAPLexer.h	2011-08-07 12:16:39 +0000
+++ src/pregen/DAAPLexer.h	2011-09-11 16:19:40 +0000
@@ -2,7 +2,7 @@
  *  This C header file was generated by $ANTLR version 3.2 debian-5
  *
  *     -  From the grammar source file : DAAP.g
- *     -                            On : 2011-08-07 12:11:34
+ *     -                            On : 2011-09-11 16:17:21
  *     -                 for the lexer : DAAPLexerLexer *
  * Editing it, at least manually, is not wise. 
  *

=== modified file 'src/pregen/DAAPParser.c'
--- src/pregen/DAAPParser.c	2011-08-07 12:16:39 +0000
+++ src/pregen/DAAPParser.c	2011-09-11 16:19:40 +0000
@@ -2,7 +2,7 @@
  *  This C source file was generated by $ANTLR version 3.2 debian-5
  *
  *     -  From the grammar source file : DAAP.g
- *     -                            On : 2011-08-07 12:11:34
+ *     -                            On : 2011-09-11 16:17:21
  *     -                for the parser : DAAPParserParser *
  * Editing it, at least manually, is not wise. 
  *

=== modified file 'src/pregen/DAAPParser.h'
--- src/pregen/DAAPParser.h	2011-08-07 12:16:39 +0000
+++ src/pregen/DAAPParser.h	2011-09-11 16:19:40 +0000
@@ -2,7 +2,7 @@
  *  This C header file was generated by $ANTLR version 3.2 debian-5
  *
  *     -  From the grammar source file : DAAP.g
- *     -                            On : 2011-08-07 12:11:34
+ *     -                            On : 2011-09-11 16:17:21
  *     -                for the parser : DAAPParserParser *
  * Editing it, at least manually, is not wise. 
  *

=== modified file 'src/pregen/RSP2SQL.c'
--- src/pregen/RSP2SQL.c	2011-08-07 12:16:39 +0000
+++ src/pregen/RSP2SQL.c	2011-09-11 16:19:40 +0000
@@ -2,7 +2,7 @@
  *  This C source file was generated by $ANTLR version 3.2 debian-5
  *
  *     -  From the grammar source file : RSP2SQL.g
- *     -                            On : 2011-08-07 12:11:36
+ *     -                            On : 2011-09-11 16:17:23
  *     -           for the tree parser : RSP2SQLTreeParser *
  * Editing it, at least manually, is not wise. 
  *
@@ -1306,6 +1306,7 @@
                 			}
 
                 			retval.result= field->factory->newRaw(field->factory);
+                			retval.result->append8(retval.result, "f.");
                 			retval.result->appendS(retval.result, field);
                 			retval.result->append8(retval.result, op);
                 			retval.result->append8(retval.result, "'");
@@ -1349,7 +1350,7 @@
 
 /** 
  * $ANTLR start strop
- * RSP2SQL.g:228:1: strop returns [ pANTLR3_COMMON_TOKEN op ] : (n= EQUAL | n= INCLUDES | n= STARTSW | n= ENDSW );
+ * RSP2SQL.g:229:1: strop returns [ pANTLR3_COMMON_TOKEN op ] : (n= EQUAL | n= INCLUDES | n= STARTSW | n= ENDSW );
  */
 static pANTLR3_COMMON_TOKEN
 strop(pRSP2SQL ctx)
@@ -1367,7 +1368,7 @@
 
     {
         {
-            //  RSP2SQL.g:230:2: (n= EQUAL | n= INCLUDES | n= STARTSW | n= ENDSW )
+            //  RSP2SQL.g:231:2: (n= EQUAL | n= INCLUDES | n= STARTSW | n= ENDSW )
             
             ANTLR3_UINT32 alt2;
 
@@ -1410,7 +1411,7 @@
             switch (alt2) 
             {
         	case 1:
-        	    // RSP2SQL.g:230:4: n= EQUAL
+        	    // RSP2SQL.g:231:4: n= EQUAL
         	    {
         	        n = (pANTLR3_BASE_TREE) MATCHT(EQUAL, &FOLLOW_EQUAL_in_strop274); 
         	        if  (HASEXCEPTION())
@@ -1425,7 +1426,7 @@
         	    }
         	    break;
         	case 2:
-        	    // RSP2SQL.g:232:4: n= INCLUDES
+        	    // RSP2SQL.g:233:4: n= INCLUDES
         	    {
         	        n = (pANTLR3_BASE_TREE) MATCHT(INCLUDES, &FOLLOW_INCLUDES_in_strop287); 
         	        if  (HASEXCEPTION())
@@ -1440,7 +1441,7 @@
         	    }
         	    break;
         	case 3:
-        	    // RSP2SQL.g:234:4: n= STARTSW
+        	    // RSP2SQL.g:235:4: n= STARTSW
         	    {
         	        n = (pANTLR3_BASE_TREE) MATCHT(STARTSW, &FOLLOW_STARTSW_in_strop300); 
         	        if  (HASEXCEPTION())
@@ -1455,7 +1456,7 @@
         	    }
         	    break;
         	case 4:
-        	    // RSP2SQL.g:236:4: n= ENDSW
+        	    // RSP2SQL.g:237:4: n= ENDSW
         	    {
         	        n = (pANTLR3_BASE_TREE) MATCHT(ENDSW, &FOLLOW_ENDSW_in_strop313); 
         	        if  (HASEXCEPTION())
@@ -1493,7 +1494,7 @@
 
 /** 
  * $ANTLR start intcrit
- * RSP2SQL.g:240:1: intcrit returns [ pANTLR3_STRING result, int valid ] : ^(o= intop f= FIELD i= INT ) ;
+ * RSP2SQL.g:241:1: intcrit returns [ pANTLR3_STRING result, int valid ] : ^(o= intop f= FIELD i= INT ) ;
  */
 static RSP2SQL_intcrit_return
 intcrit(pRSP2SQL ctx)
@@ -1517,8 +1518,8 @@
     retval.start = LT(1); retval.stop = retval.start;
 
     {
-        // RSP2SQL.g:242:2: ( ^(o= intop f= FIELD i= INT ) )
-        // RSP2SQL.g:242:4: ^(o= intop f= FIELD i= INT )
+        // RSP2SQL.g:243:2: ( ^(o= intop f= FIELD i= INT ) )
+        // RSP2SQL.g:243:4: ^(o= intop f= FIELD i= INT )
         {
             FOLLOWPUSH(FOLLOW_intop_in_intcrit342);
             o=intop(ctx);
@@ -1605,6 +1606,7 @@
                 			}
 
                 			retval.result= field->factory->newRaw(field->factory);
+                			retval.result->append8(retval.result, "f.");
                 			retval.result->appendS(retval.result, field);
                 			retval.result->append8(retval.result, op);
                 			retval.result->appendS(retval.result, i->getText(i));
@@ -1637,7 +1639,7 @@
 
 /** 
  * $ANTLR start intop
- * RSP2SQL.g:301:1: intop returns [ pANTLR3_COMMON_TOKEN op ] : (n= EQUAL | n= LESS | n= GREATER | n= LTE | n= GTE );
+ * RSP2SQL.g:303:1: intop returns [ pANTLR3_COMMON_TOKEN op ] : (n= EQUAL | n= LESS | n= GREATER | n= LTE | n= GTE );
  */
 static pANTLR3_COMMON_TOKEN
 intop(pRSP2SQL ctx)
@@ -1655,7 +1657,7 @@
 
     {
         {
-            //  RSP2SQL.g:303:2: (n= EQUAL | n= LESS | n= GREATER | n= LTE | n= GTE )
+            //  RSP2SQL.g:305:2: (n= EQUAL | n= LESS | n= GREATER | n= LTE | n= GTE )
             
             ANTLR3_UINT32 alt3;
 
@@ -1703,7 +1705,7 @@
             switch (alt3) 
             {
         	case 1:
-        	    // RSP2SQL.g:303:4: n= EQUAL
+        	    // RSP2SQL.g:305:4: n= EQUAL
         	    {
         	        n = (pANTLR3_BASE_TREE) MATCHT(EQUAL, &FOLLOW_EQUAL_in_intop383); 
         	        if  (HASEXCEPTION())
@@ -1718,7 +1720,7 @@
         	    }
         	    break;
         	case 2:
-        	    // RSP2SQL.g:305:4: n= LESS
+        	    // RSP2SQL.g:307:4: n= LESS
         	    {
         	        n = (pANTLR3_BASE_TREE) MATCHT(LESS, &FOLLOW_LESS_in_intop396); 
         	        if  (HASEXCEPTION())
@@ -1733,7 +1735,7 @@
         	    }
         	    break;
         	case 3:
-        	    // RSP2SQL.g:307:4: n= GREATER
+        	    // RSP2SQL.g:309:4: n= GREATER
         	    {
         	        n = (pANTLR3_BASE_TREE) MATCHT(GREATER, &FOLLOW_GREATER_in_intop409); 
         	        if  (HASEXCEPTION())
@@ -1748,7 +1750,7 @@
         	    }
         	    break;
         	case 4:
-        	    // RSP2SQL.g:309:4: n= LTE
+        	    // RSP2SQL.g:311:4: n= LTE
         	    {
         	        n = (pANTLR3_BASE_TREE) MATCHT(LTE, &FOLLOW_LTE_in_intop422); 
         	        if  (HASEXCEPTION())
@@ -1763,7 +1765,7 @@
         	    }
         	    break;
         	case 5:
-        	    // RSP2SQL.g:311:4: n= GTE
+        	    // RSP2SQL.g:313:4: n= GTE
         	    {
         	        n = (pANTLR3_BASE_TREE) MATCHT(GTE, &FOLLOW_GTE_in_intop435); 
         	        if  (HASEXCEPTION())
@@ -1801,7 +1803,7 @@
 
 /** 
  * $ANTLR start datecrit
- * RSP2SQL.g:315:1: datecrit returns [ pANTLR3_STRING result, int valid ] : ^(o= dateop f= FIELD d= datespec ) ;
+ * RSP2SQL.g:317:1: datecrit returns [ pANTLR3_STRING result, int valid ] : ^(o= dateop f= FIELD d= datespec ) ;
  */
 static RSP2SQL_datecrit_return
 datecrit(pRSP2SQL ctx)
@@ -1827,8 +1829,8 @@
     retval.start = LT(1); retval.stop = retval.start;
 
     {
-        // RSP2SQL.g:317:2: ( ^(o= dateop f= FIELD d= datespec ) )
-        // RSP2SQL.g:317:4: ^(o= dateop f= FIELD d= datespec )
+        // RSP2SQL.g:319:2: ( ^(o= dateop f= FIELD d= datespec ) )
+        // RSP2SQL.g:319:4: ^(o= dateop f= FIELD d= datespec )
         {
             FOLLOWPUSH(FOLLOW_dateop_in_datecrit464);
             o=dateop(ctx);
@@ -1916,6 +1918,7 @@
                 			}
 
                 			retval.result= field->factory->newRaw(field->factory);
+                			retval.result->append8(retval.result, "f.");
                 			retval.result->appendS(retval.result, field);
                 			retval.result->append8(retval.result, op);
                 			retval.result->append8(retval.result, buf);
@@ -1948,7 +1951,7 @@
 
 /** 
  * $ANTLR start dateop
- * RSP2SQL.g:374:1: dateop returns [ pANTLR3_COMMON_TOKEN op ] : (n= BEFORE | n= AFTER );
+ * RSP2SQL.g:377:1: dateop returns [ pANTLR3_COMMON_TOKEN op ] : (n= BEFORE | n= AFTER );
  */
 static pANTLR3_COMMON_TOKEN
 dateop(pRSP2SQL ctx)
@@ -1966,7 +1969,7 @@
 
     {
         {
-            //  RSP2SQL.g:376:2: (n= BEFORE | n= AFTER )
+            //  RSP2SQL.g:379:2: (n= BEFORE | n= AFTER )
             
             ANTLR3_UINT32 alt4;
 
@@ -1999,7 +2002,7 @@
             switch (alt4) 
             {
         	case 1:
-        	    // RSP2SQL.g:376:4: n= BEFORE
+        	    // RSP2SQL.g:379:4: n= BEFORE
         	    {
         	        n = (pANTLR3_BASE_TREE) MATCHT(BEFORE, &FOLLOW_BEFORE_in_dateop505); 
         	        if  (HASEXCEPTION())
@@ -2014,7 +2017,7 @@
         	    }
         	    break;
         	case 2:
-        	    // RSP2SQL.g:378:4: n= AFTER
+        	    // RSP2SQL.g:381:4: n= AFTER
         	    {
         	        n = (pANTLR3_BASE_TREE) MATCHT(AFTER, &FOLLOW_AFTER_in_dateop518); 
         	        if  (HASEXCEPTION())
@@ -2052,7 +2055,7 @@
 
 /** 
  * $ANTLR start datespec
- * RSP2SQL.g:382:1: datespec returns [ time_t date, int valid ] : (r= dateref | ^(o= dateop r= dateref m= INT i= dateintval ) );
+ * RSP2SQL.g:385:1: datespec returns [ time_t date, int valid ] : (r= dateref | ^(o= dateop r= dateref m= INT i= dateintval ) );
  */
 static RSP2SQL_datespec_return
 datespec(pRSP2SQL ctx)
@@ -2083,7 +2086,7 @@
 
     {
         {
-            //  RSP2SQL.g:384:2: (r= dateref | ^(o= dateop r= dateref m= INT i= dateintval ) )
+            //  RSP2SQL.g:387:2: (r= dateref | ^(o= dateop r= dateref m= INT i= dateintval ) )
             
             ANTLR3_UINT32 alt5;
 
@@ -2118,7 +2121,7 @@
             switch (alt5) 
             {
         	case 1:
-        	    // RSP2SQL.g:384:4: r= dateref
+        	    // RSP2SQL.g:387:4: r= dateref
         	    {
         	        FOLLOWPUSH(FOLLOW_dateref_in_datespec546);
         	        r=dateref(ctx);
@@ -2141,7 +2144,7 @@
         	    }
         	    break;
         	case 2:
-        	    // RSP2SQL.g:391:4: ^(o= dateop r= dateref m= INT i= dateintval )
+        	    // RSP2SQL.g:394:4: ^(o= dateop r= dateref m= INT i= dateintval )
         	    {
         	        FOLLOWPUSH(FOLLOW_dateop_in_datespec560);
         	        o=dateop(ctx);
@@ -2251,7 +2254,7 @@
 
 /** 
  * $ANTLR start dateref
- * RSP2SQL.g:426:1: dateref returns [ time_t date, int valid ] : (n= DATE | TODAY );
+ * RSP2SQL.g:429:1: dateref returns [ time_t date, int valid ] : (n= DATE | TODAY );
  */
 static RSP2SQL_dateref_return
 dateref(pRSP2SQL ctx)
@@ -2270,7 +2273,7 @@
 
     {
         {
-            //  RSP2SQL.g:428:2: (n= DATE | TODAY )
+            //  RSP2SQL.g:431:2: (n= DATE | TODAY )
             
             ANTLR3_UINT32 alt6;
 
@@ -2303,7 +2306,7 @@
             switch (alt6) 
             {
         	case 1:
-        	    // RSP2SQL.g:428:4: n= DATE
+        	    // RSP2SQL.g:431:4: n= DATE
         	    {
         	        n = (pANTLR3_BASE_TREE) MATCHT(DATE, &FOLLOW_DATE_in_dateref607); 
         	        if  (HASEXCEPTION())
@@ -2345,7 +2348,7 @@
         	    }
         	    break;
         	case 2:
-        	    // RSP2SQL.g:457:4: TODAY
+        	    // RSP2SQL.g:460:4: TODAY
         	    {
         	         MATCHT(TODAY, &FOLLOW_TODAY_in_dateref616); 
         	        if  (HASEXCEPTION())
@@ -2383,7 +2386,7 @@
 
 /** 
  * $ANTLR start dateintval
- * RSP2SQL.g:461:1: dateintval returns [ time_t period, int valid ] : ( DAY | WEEK | MONTH | YEAR );
+ * RSP2SQL.g:464:1: dateintval returns [ time_t period, int valid ] : ( DAY | WEEK | MONTH | YEAR );
  */
 static RSP2SQL_dateintval_return
 dateintval(pRSP2SQL ctx)
@@ -2399,7 +2402,7 @@
 
     {
         {
-            //  RSP2SQL.g:463:2: ( DAY | WEEK | MONTH | YEAR )
+            //  RSP2SQL.g:466:2: ( DAY | WEEK | MONTH | YEAR )
             
             ANTLR3_UINT32 alt7;
 
@@ -2442,7 +2445,7 @@
             switch (alt7) 
             {
         	case 1:
-        	    // RSP2SQL.g:463:4: DAY
+        	    // RSP2SQL.g:466:4: DAY
         	    {
         	         MATCHT(DAY, &FOLLOW_DAY_in_dateintval640); 
         	        if  (HASEXCEPTION())
@@ -2457,7 +2460,7 @@
         	    }
         	    break;
         	case 2:
-        	    // RSP2SQL.g:465:4: WEEK
+        	    // RSP2SQL.g:468:4: WEEK
         	    {
         	         MATCHT(WEEK, &FOLLOW_WEEK_in_dateintval649); 
         	        if  (HASEXCEPTION())
@@ -2472,7 +2475,7 @@
         	    }
         	    break;
         	case 3:
-        	    // RSP2SQL.g:467:4: MONTH
+        	    // RSP2SQL.g:470:4: MONTH
         	    {
         	         MATCHT(MONTH, &FOLLOW_MONTH_in_dateintval658); 
         	        if  (HASEXCEPTION())
@@ -2487,7 +2490,7 @@
         	    }
         	    break;
         	case 4:
-        	    // RSP2SQL.g:469:4: YEAR
+        	    // RSP2SQL.g:472:4: YEAR
         	    {
         	         MATCHT(YEAR, &FOLLOW_YEAR_in_dateintval667); 
         	        if  (HASEXCEPTION())

=== modified file 'src/pregen/RSP2SQL.h'
--- src/pregen/RSP2SQL.h	2011-08-07 12:16:39 +0000
+++ src/pregen/RSP2SQL.h	2011-09-11 16:19:40 +0000
@@ -2,7 +2,7 @@
  *  This C header file was generated by $ANTLR version 3.2 debian-5
  *
  *     -  From the grammar source file : RSP2SQL.g
- *     -                            On : 2011-08-07 12:11:36
+ *     -                            On : 2011-09-11 16:17:23
  *     -           for the tree parser : RSP2SQLTreeParser *
  * Editing it, at least manually, is not wise. 
  *

=== modified file 'src/pregen/RSPLexer.c'
--- src/pregen/RSPLexer.c	2011-08-07 12:16:39 +0000
+++ src/pregen/RSPLexer.c	2011-09-11 16:19:40 +0000
@@ -2,7 +2,7 @@
  *  This C source file was generated by $ANTLR version 3.2 debian-5
  *
  *     -  From the grammar source file : RSP.g
- *     -                            On : 2011-08-07 12:11:35
+ *     -                            On : 2011-09-11 16:17:22
  *     -                 for the lexer : RSPLexerLexer *
  * Editing it, at least manually, is not wise. 
  *

=== modified file 'src/pregen/RSPLexer.h'
--- src/pregen/RSPLexer.h	2011-08-07 12:16:39 +0000
+++ src/pregen/RSPLexer.h	2011-09-11 16:19:40 +0000
@@ -2,7 +2,7 @@
  *  This C header file was generated by $ANTLR version 3.2 debian-5
  *
  *     -  From the grammar source file : RSP.g
- *     -                            On : 2011-08-07 12:11:35
+ *     -                            On : 2011-09-11 16:17:22
  *     -                 for the lexer : RSPLexerLexer *
  * Editing it, at least manually, is not wise. 
  *

=== modified file 'src/pregen/RSPParser.c'
--- src/pregen/RSPParser.c	2011-08-07 12:16:39 +0000
+++ src/pregen/RSPParser.c	2011-09-11 16:19:40 +0000
@@ -2,7 +2,7 @@
  *  This C source file was generated by $ANTLR version 3.2 debian-5
  *
  *     -  From the grammar source file : RSP.g
- *     -                            On : 2011-08-07 12:11:35
+ *     -                            On : 2011-09-11 16:17:22
  *     -                for the parser : RSPParserParser *
  * Editing it, at least manually, is not wise. 
  *

=== modified file 'src/pregen/RSPParser.h'
--- src/pregen/RSPParser.h	2011-08-07 12:16:39 +0000
+++ src/pregen/RSPParser.h	2011-09-11 16:19:40 +0000
@@ -2,7 +2,7 @@
  *  This C header file was generated by $ANTLR version 3.2 debian-5
  *
  *     -  From the grammar source file : RSP.g
- *     -                            On : 2011-08-07 12:11:35
+ *     -                            On : 2011-09-11 16:17:22
  *     -                for the parser : RSPParserParser *
  * Editing it, at least manually, is not wise. 
  *

=== modified file 'src/transcode.c'
--- src/transcode.c	2011-06-20 18:15:23 +0000
+++ src/transcode.c	2011-09-11 16:19:40 +0000
@@ -353,7 +353,11 @@
     }
   memset(ctx, 0, sizeof(struct transcode_ctx));
 
+#if LIBAVFORMAT_VERSION_MAJOR >= 53 || (LIBAVFORMAT_VERSION_MAJOR == 53 && LIBAVCODEC_VERSION_MINOR >= 3)
+  ret = avformat_open_input(&ctx->fmtctx, mfi->path, NULL, NULL);
+#else
   ret = av_open_input_file(&ctx->fmtctx, mfi->path, NULL, 0, NULL);
+#endif
   if (ret != 0)
     {
       DPRINTF(E_WARN, L_XCODE, "Could not open file %s: %s\n", mfi->fname, strerror(AVUNERROR(ret)));
@@ -449,7 +453,9 @@
 	}
 
       ctx->need_resample = 1;
-#if LIBAVCODEC_VERSION_MAJOR >= 53
+#if LIBAVUTIL_VERSION_MAJOR >= 51 || (LIBAVUTIL_VERSION_MAJOR == 51 && LIBAVUTIL_VERSION_MINOR >= 4)
+      ctx->input_size = ctx->acodec->channels * av_get_bytes_per_sample(ctx->acodec->sample_fmt);
+#elif LIBAVCODEC_VERSION_MAJOR >= 53
       ctx->input_size = ctx->acodec->channels * av_get_bits_per_sample_fmt(ctx->acodec->sample_fmt) / 8;
 #else
       ctx->input_size = ctx->acodec->channels * av_get_bits_per_sample_format(ctx->acodec->sample_fmt) / 8;

